#!/bin/bash

echo "Booting.."

# hostname

echo "  Hostname"
export `cat /etc/conf.d/hostname`
hostname "$hostname"


# modules

echo "  Loading modules"
MODULES="usb_f_acm u_serial libcomposite ci_hdrc_imx usbmisc_imx ci_hdrc m25p80 spi_nor spidev spi_mxs"
#MODULES="g_serial u_serial libcomposite usb_f_acm"
for m in $MODULES; do
  modprobe $m
done

modprobe g_serial iManufacturer="DirectOut" iProduct="M.1k2" idVendor=0x16D0 idProduct=0x0001

#insmod /lib/modules/4.0.5-gentoo/kernel/drivers/w1/slaves/w1_ioboard.ko &
#insmod /lib/modules/4.9.6-gentoo-r1/kernel/drivers/w1/slaves/w1_ioboard.ko &

# fsck

echo "  Fsck"
fsck -a /dev/mmcblk0p5 | tail -n 1
fsck -a /dev/mmcblk0p6 | tail -n 1
fsck -a /dev/mmcblk0p7 | tail -n 1
fsck -a /dev/mmcblk0p9 | tail -n 1


# localmount

echo "  Mounting"
#mount -t ext4 -o noatime,nodiratime /dev/mmcblk0p5 /static
mount -t ext4 -o noatime,nodiratime /dev/mmcblk0p6 /config
mount -t ext4 -o noatime,nodiratime /dev/mmcblk0p7 /user
mount -t ext4 -o noatime,nodiratime /dev/mmcblk0p9 /var

rm -rf /tmpdata/upgrade/* &

# loopback

echo "  Setting up loopback"
ip addr add 127.0.0.1/8 dev lo brd + scope host
ip route add 127.0.0.0/8 dev lo scope host
ip link set lo up


# swap

#echo "  Activating swap"
#swapon /dev/mmcblk0p8


# sysctl

echo "  Sysctl"
echo 0 > /proc/sys/net/ipv4/ip_forward
echo 1 > /proc/sys/net/ipv4/conf/all/rp_filter



# ram disks

echo "  Mouting RAM disks"
mount -t tmpfs -o size=10M tmpfs /var/log
mkdir /var/log/scripts
mount -t tmpfs -o size=1M tmpfs /var/log/scripts

mount -t tmpfs tmpfs /tmp
mkdir /tmp/sfp

mount -t tmpfs tmpfs /tmpdata

# static

#echo "  Mounting /static"
mount -t jffs2 /dev/mtdblock1 /static


# w1
echo 1 > /sys/bus/w1/devices/w1_bus_master1/w1_master_max_slave_count
echo 1 > /sys/bus/w1/devices/w1_bus_master2/w1_master_max_slave_count
echo 1 > /sys/bus/w1/devices/w1_bus_master3/w1_master_max_slave_count

