/**
 * M1k2 source/dest view
 * (c) D.O.Tec, http://www.directout.eu
 * @version 1 (13.11.2010) Florian Faber, florian.faber@directout.eu
 **/

type = 1;
display = 1;
filter = 1;

selectionstart = -1;
selectionmask = [];
selectioncnt = 0;

channel_routing = null;


function submit_view_settings() {
  /* on every change submit the settings so they can be stored in the user profile */
}



function update_channel(ch) {
  alert("update_channel("+ch+")");
  var o = document.getElementById("ch"+(Math.floor(ch/64)+1)+"_"+(ch%64+1));
  if (type==1) {
    if (channel_routing[ch]==-1) {
      o.children[0].innerHTML="";
      o.children[0].style.backgroundColor = "";
      if (o.children[2]) o.children[2].style.display = "none";
    } else {
      if ((display==1) || (display==2)) {
	o.children[0].innerHTML=src_channel_names[channel_routing[ch]];
      }
    }
  }
}


function clear_routes() {
  var i, j, cmds = [];
  
  if (type==1) { // sink ports
    for (i=0; i<1024; i++) {
      if ((selectionmask[i]==1) && (channel_routing[i]>-1)) {
	//cmds.push("delroute "+channel_routing[i]+" "+i);
	channel_routing[i] = -1;
	update_channel(i);
      }
    }
    
  } else if (type==2) { // source ports
    for (i=0; i<1024; i++) {
      if (selectionmask[i]==1) {
	for (j=0; j<1024; j++) {
	  if (channel_routing[j]==i) {
	    cmds.push("delroute "+i+" "+j);
	    channel_routing[j] = -1;
	    update_channel(i);
	  }
	}
      }
    }
  }
}

function clear_selectionmask() {
  for (var i=0; i<1024; i++) {
    selectionmask[i] = 0;
  }
}


function update_channel_selection(port, channel) {
  var o = document.getElementById("ch"+(port+1)+"_"+(channel+1));
  if (o) {
    if (type==2) {
      if (selectionmask[port*64+channel]==1) {
	//o.style.border = "1px solid white";
	o.style.background = "url(/img/channel_dest_selected.png)";
      } else {
      //o.style.border = "1px solid black";
	o.style.background = "url(/img/channel_dest.png)";
      }
    } else if (type==1) {
      if (selectionmask[port*64+channel]==1) {
	o.style.background = "url(/img/channel_source_selected.png)";
      } else {
	o.style.background = "url(/img/channel_source.png)";
      }

    }
  } else {
    alert("update_channel_selection: channel "+port+"/"+channel+" not found");
  }
}


function update_toolbox_info() {
  var o = document.getElementById("toolinfo");
  var b1 = document.getElementById("toolgroup");
  var b2 = document.getElementById("toolroute");
  var b3 = document.getElementById("toolclear");
  var b4 = document.getElementById("toolunroute");

  if (selectioncnt==0) {
    o.innerHTML = toolinfo_n;
    b1.disabled = true;
    b2.disabled = true;
    b3.disabled = true;
    b4.disabled = true;
  } else if (selectioncnt==1) {
    o.innerHTML = toolinfo_s;
    b1.disabled = true;
    b2.disabled = false;
    b3.disabled = false;
    b4.disabled = false;
  } else {
    o.innerHTML = selectioncnt+" "+toolinfo_p;
    b1.disabled = false;
    b2.disabled = false;
    b3.disabled = false;
    b4.disables = false;
  }
  if (type==1) {
    b2.disables = true;
  }
}


function clear_channel_selection() {
  for (var i=0; i<1024; i++) {
    if (selectionmask[i]==1) {
      selectionmask[i]=0;
      update_channel_selection(Math.floor(i/64), i%64);
    }
  }
  selectioncnt = 0;
  selectionstart = -1;
  update_toolbox_info();
}




function channel_clicked(ev, ch, port, channel) {
  var idx = port*64+channel;

  if (ev.ctrlKey) {
    selectionmask[idx] = 1-selectionmask[idx];
    if (selectionmask[idx]==0) { 
      selectioncnt--;
    } else {
      selectioncnt++;
    }
    update_toolbox_info();
    update_channel_selection(port, channel);
    
  } else if (ev.shiftKey) {
    if (selectionstart==-1) {
      clear_channel_selection();
      selectionstart = idx;
      selectionmask[idx] = 1;
      selectioncnt = 1;
      update_channel_selection(port, channel);
    } else {
      selectioncnt = 0;
      
      if (idx>selectionstart) {
	for (var i=selectionstart; i<=idx; i++) {
	  selectionmask[i] = 1;
	  update_channel_selection(Math.floor(i/64), i%64);
	  selectioncnt++;
	}
      } else {
	for (var i=selectionstart; i>=idx; i--) {
	  selectionmask[i] = 1;
	  update_channel_selection(Math.floor(i/64), i%64);
	  selectioncnt++;
	}
      }
      selectionstart = -1;
    }
    
    update_toolbox_info();
    
  } else {
    if (type==1) {
      channeldialog_open(1, selectionmask, selectioncnt);
    
    } else if (type==2) {
      var channels = [];
      var cnt = 0;
      
      for (var i=0; i<1024; i++) {
	if (channel_routing[i]==idx) {
	  cnt++;
	  channels.push(i);
	}
      }
      
      if (cnt>0) {
	channeldialog_inspector(idx, channels);
      }
    }
  }
}


function filter_channel(o, p, c) {
  if (!o) return;

  switch (filter) {
  case 1: // all channels
    o.style.display = 'block';
    break;
    
  case 2: // connected
    if (channel_routing[(p-1)*64+(c-1)]>0) {
      o.style.display = 'block';
    } else {
      o.style.display = 'none';
    }
    break;

  case 3: // unconnected
    if (channel_routing[(p-1)*64+(c-1)]==0) {
      o.style.display = 'block';
    } else {
      o.style.display = 'none';
    }
    break;

  case 4: // with signal
    if ((channel_state[(p-1)*64+(c-1)] & 2)==2) {
      o.style.display = 'block';
    } else {
      o.style.display = 'none';
    }
    break;


  case 5: // without signal
    if ((channel_state[(p-1)*64+(c-1)] & 2)==0) {
      o.style.display = 'block';
    } else {
      o.style.display = 'none';
    }
    break;

  case 6: // muted
    if ((channel_state[(p-1)*64+(c-1)] & 8)==8) {
      o.style.display = 'block';
    } else {
      o.style.display = 'none';
    }
  }
}




function ports_changed() {

}


function groups_changed() {

}


function show_port(port, active) {
  var obj = document.getElementById("port"+(port));
  if (obj) {
    if (active) {
      obj.style.display = 'block';
      
      obj = document.getElementById("port"+(port)+"_title");
      if (obj) {
	if (type==1) {
	  obj.innerHTML = "Output Port "+(port)+": "+dest_port_names[port-1];
	} else if (type==2) {
	  obj.innerHTML = "Input Port "+(port)+": "+src_port_names[port-1];
	}
      }
    } else {
      obj.style.display = 'none';
    }
  }
}


function hide_all_ports() {
  var i, o;
  for (i=1; i<=16; i++) {
    o = document.getElementById("port"+i);
    if (o) {
      o.style.display='none';
    }
  }
}


function show_group(idx, active) {
  var obj, title;

  obj = document.getElementById("group"+(idx));
  title = document.getElementById("group"+(idx)+"_title");

  if (obj) {
    if (active) {
      obj.style.display = 'block';
      title.innerHTML = channelgroup_names[idx-1];
    } else {
      obj.style.display = 'none';
    }
  }
}


function hide_groups() {
  var o;
  for (var i=0; i<channelgroup_names.length; i++) {
    if (type==1) {
      o = document.getElementById("dgroup"+i);
      if (o) o.style.display='none';
    } else if (type==2) {
      o = document.getElementById("sgroup"+i);
      if (o) o.style.display='none';
    }
  }
}



function clear_table(t) {
  if (!t) return;

  var channels = t.getElementsByTagName("div")[0];

  if (channels) {
    t.removeChild(channels);
    
    channels = document.createElement("div");
    channels.className = 'channels';
    t.appendChild(channels);
  }
}


function clear_all_port_tables() {
  for (var i=1; i<=16; i++) {
    clear_table(document.getElementById("port"+i));
  }
}


function clear_all_group_tables() {
  for (var i=0; i<channelgroup_names.length; i++) {
    clear_table(document.getElementById("group"+(i+1)));
  }
}


function add_channel(channels, port, channel, id, srcname, srccolor, srcbg, destname, destcolor, destbg, data, signal, mute) {
  var obj, txt;
  var ch = document.createElement("div");
  ch.id = id;
  if (type==1) {
    if (data) {
      ch.className = 'channel data srcchannel';
    } else {
      ch.className = 'channel srcchannel';
    } 
  } else if (type==2) {
    if (data) {
      ch.className = 'channel data destchannel';
    } else {
      ch.className = 'channel destchannel';
    } 
  }

  obj = document.createElement("div");
  obj.className = 'source';
  if (srccolor) obj.style.color = "#"+srccolor;
  if (srcbg)    obj.style.backgroundColor = "#"+srcbg;
  obj.innerHTML = srcname;
  ch.appendChild(obj);

  obj = document.createElement("div");
  obj.className = 'dest';
  if (destcolor) obj.style.color = "#"+destcolor;
  if (destbg)    obj.style.backgroundColor = "#"+destbg;
  obj.innerHTML = destname;
  ch.appendChild(obj);

  ch.onclick = function(ev){ channel_clicked(ev, ch, port, channel); };

  if (signal) {
    obj = document.createElement("img");
    obj.className = 'signal';
    obj.id = id+"_signal";
    obj.src = "/img/led7_green.png";
    ch.appendChild(obj);
  }

  if (mute) {
    obj = document.createElement("img");
    obj.className = 'mute';
    obj.id = id+"_mute";
    obj.src = "/img/mute7_on.png";
    ch.appendChild(obj);
  }

  channels.appendChild(ch);
  filter_channel(ch, port+1, channel+1);
}


function get_src_destinations(ch) {
  var i, res=0;
  return res;
}


function rebuild_port(port) {
  var table = document.getElementById("port"+(port));
  var channels = table.getElementsByTagName("div")[0];
  var idx, cnt, lastfound;

  if (channels) {
    
    for (var i=0; i<64; i++) {
      idx = (port-1)*64 + i;

      srcname = null;
      srccolor = null;
      srcbg = null;
      destname = null;
      destcolor = null;
      destbg = null;
      data = null;
      signal = null;
      mute = null;
	
      if ((type==1) && (channel_state[idx]&16)) { // sink view
	if (channel_routing[(port-1)*64+i]>-1) {  
	  srcname = src_names[channel_routing[(port-1)*64+i]];
	  data = channel_state[channel_routing[(port-1)*64+i]] & 4;
	  signal = channel_state[channel_routing[(port-1)*64+i]] & 2;
	  mute = channel_state[channel_routing[(port-1)*64+i]] & 8;
	}
	
	if (display==1) {
	  destname = dest_names[(port-1)*64+i];
	  destbg = "aaa";
		  
	} else if (display==2) { // port, group
	  if (dest_channel_groups[(port-1)*64+i]>-1) {
	    var groupid = dest_channel_groups[(port-1)*64+i]-1;
	    var groupidx = dest_channel_group_idx[(port-1)*64+i];
	    destname =  group_channelnames[dest_channel_groups[(port-1)*64+i]-1][dest_channel_group_idx[(port-1)*64+i]];
	    destbg = channelgroup_colors[dest_channel_groups[(port-1)*64+i]-1];
	    destcolor = 'fff';
	  } else {
	    destname = dest_names[(port-1)*64+i];
	    destbg = "aaa";
	  }
	}
	
	add_channel(channels, port-1, i, "ch"+port+"_"+(i+1), 
		    srcname, srccolor, srcbg,
		    destname, destcolor, destbg,
		    data, signal, mute);

      } else if ((type==2) && (channel_state[idx]&1)) { // source view
	srcname = src_names[(port-1)*64+i];



	if (display==2) {

	  if (src_channel_groups[(port-1)*64+i]>-1) {
	    srcname = group_channelnames[src_channel_groups[(port-1)*64+i]-1][src_channel_group_idx[(port-1)*64+i]];
	  } else {
	    srcname = "";
	  }
	  srcbg = channelgroup_colors[src_channel_groups[(port-1)*64+i]-1];
	  srccolor = 'fff';


	  if (src_channel_groups[(port-1)*64+i]>-1) {
	    var groupid = src_channel_groups[(port-1)*64+i]-1;
	    var groupidx = src_channel_group_idx[(port-1)*64+i];
	    srcname = group_channelnames[groupid][groupidx];
	    srcbg = channelgroup_colors[groupid];
	    srccolor = 'fff';
	  }
	}

	cnt = 0;
	lastfound = -1;
	
	for (j=0; j<1024; j++) {
	  if (channel_routing[j]==(port-1)*64+i) {
	    cnt++;
	    lastfound = j;
	  }
	}

	if (cnt==0) {
	  destname = null;
	} else if (cnt==1) {
	  destname = dest_names[lastfound];
	} else {
	  destname = cnt;
	  destcolor = "703636";
	}
	
	add_channel(channels, port-1, i, "ch"+port+"_"+(i+1), 
		    srcname, srccolor, srcbg, 
		    destname, destcolor, destbg,
		    channel_state[(port-1)*64+i] & 4, 
		    channel_state[(port-1)*64+i] & 2, 
		    channel_state[(port-1)*64+i] & 8);
      }
    }

    sep = document.createElement("div");
    sep.style.clear = 'both';
    channels.appendChild(sep);
  }
}


function rebuild_src_group(srcgroupid) {
  var table = document.getElementById("sgroup"+(srcgroupid));
  var channels = table.getElementsByTagName("div")[0];
  var srcport, srcch, destport, destch, destname, destcolor, destbg, i, j;

  for (i=0; i<src_group_channels[srcgroupid-1].length; i++) {
    srcport = Math.floor(src_group_channels[srcgroupid-1][i]/64);
    srcch = src_group_channels[srcgroupid-1][i]%64;

    if (display==3) {
      // group, port: src=group, dest=ch
      if (channel_routing[srcport*64+srcch]>-1) {
	destport = Math.floor(channel_routing[srcport*64+srcch]/64);
	destch = channel_routing[srcport*64+srcch] % 64;
	destname = dest_names[channel_routing[srcport*64+srcch]];
      } else {
	destport = null;
	destch = null;
	destname = null;
      }
      
      
      add_channel(channels, srcport, srcch, 
		  "src"+srcgroupid+"_"+i, 
		  src_group_channel_names[srcgroupid-1][i],
		  'fff',
		  src_group_colors[srcgroupid-1],
		  destname,
		  null,
		  null,
		  channel_state[(srcport-1)*64+i] & 4, 
		  channel_state[(srcport-1)*64+i] & 2, 
		  channel_state[(srcport-1)*64+i] & 8);

    } else if (display==4) {
      // group, group: src=group, dest=group
      if (channel_routing[srcport*64+srcch]>-1) {
	destport = Math.floor(channel_routing[srcport*64+srcch]/64);
	destch = channel_routing[srcport*64+srcch] % 64;
	
	// find group for that channel
	for (j=0; j<1024; j++) {
	  if (dest_channel_groups[i]==channel_routing[srcport*64+srcch]) {
	    destname = group_channel_names[dest_channel_groups[i]][dest_channel_group_idx[i]];
	    destcolor = 'fff';
	    destbg = group_colors[dest_channel_groups[i]];
	    j = 1024;
	  }
	}
	if (j==1024) {
	  destname = dest_names[channel_routing[srcport*64+srcch]];
	  destcolor = null;
	  destbg = null;
	}
      } else {
	destport = null;
	destch = null;
	destname = null;
	destcolor = null;
	destbg = null;
      }
      
      add_channel(channels, srcport, srcch, 
		  "src"+srcgroupid+"_"+i, 
		  src_group_channel_names[srcgroupid-1][i],
		  'fff',
		  src_group_colors[srcgroupid-1],
		  destname,
		  destcolor,
		  destbg,
		  channel_state[(srcport-1)*64+i] & 4, 
		  channel_state[(srcport-1)*64+i] & 2, 
		  channel_state[(srcport-1)*64+i] & 8);
    }
  }

  sep = document.createElement("div");
  sep.style.clear = 'both';
  channels.appendChild(sep);
}


function create_table(name, id) {
  var t, o;

  t = document.createElement("div");
  t.className = "routingtableentry";
  t.id = id;
  
  o = document.createElement("h1");
  o.innerHTML = name;
  t.appendChild(o);

  o = document.createElement("div");
  o.className = "channels";
  t.appendChild(o);
  /*
  o = document.createElement("div");
  o.style.clear = 'both';
  t.children[1].appendChild(o);
  */
  return t;
}


function add_group(groupid, mode) {
  var table = create_table(channelgroup_names[groupid], ((mode==1)?"dgroup":"sgroup")+groupid);
  var channels = table.children[1];
  var destport, destch, destport, destch, destname, destcolor, destbg, i, j, data, signal, mute;
  var groupchannels, idx;

  if (mode==1) {
    groupchannels = dest_group_channels;
    for (idx=0; idx<dest_groups.length; idx++) {
      if (dest_groups[idx]==groupid) break;
    }
  } else if (mode==2) {
    groupchannels = src_group_channels;
    for (idx=0; idx<src_groups.length; idx++) {
      if (src_groups[idx]==groupid) break;
    }
  }

  for (i=0; i<groupchannels[idx].length; i++) {
    destport = Math.floor(groupchannels[idx]/64);
    destch = groupchannels[idx][i]%64;

    if (display==3) {
      // group, port: src=group, dest=ch
      if (channel_routing[destport*64+destch]>-1) {
	srcport = Math.floor((channel_routing[destport*64+destch])/64);
	srcch = (channel_routing[destport*64+destch]) % 64;
	srcname = src_names[srcport*64+srcch];
	data = channel_state[(srcport)*64+srcch] & 4;
	signal = channel_state[(srcport)*64+srcch] & 2;
	mute = channel_state[(srcport)*64+srcch] & 8;
      } else {
	srcport = null;
	srcch = null;
	srcname = null;
	data = null;
	signal = null;
	mute = null;
      }
      
      
      add_channel(channels, destport, destch, "ch"+groupid+"_"+(i+1), 
		  srcname, null, null,
		  group_channelnames[groupid-1][i], 'fff', channelgroup_colors[groupid-1],
		  data, signal, mute);

    } else if (display==4) {
      // group, group: src=group, dest=group
      if (channel_routing[destport*64+destch]>-1) {
	srcport = Math.floor(channel_routing[destport*64+destch]/64);
	srcch = channel_routing[destport*64+destch] % 64;
	if (src_channel_groups[srcport*64+srcch]>-1) {
	  srcname = src_group_channel_names[src_channel_groups[srcport*64+srcch]][src_channel_group_idx[srcport*64+srcch]];
	  srcbg = src_group_colors[src_channel_groups[srcport*64+srcch]];
	  srccolor = 'fff';
	} else {
	  srcname = src_names[srcport*64+srcch];
	  srcbg = null;
	  srccolor = '000';
	}
	data = channel_state[srcport*64+srcch] & 4;
	signal = channel_state[srcport*64+srcch] & 2;
	mute = channel_state[srcport*64+srcch] & 8;
      } else {
	srcname = null;
	srcbg = null;
	data = null;
	signal = null;
	mute = null;
      }
      
      add_channel(channels, destport, destch, "ch"+groupid+"_"+(i+1), 
		  srcname, srccolor, srcbg,
		  dest_group_channel_names[groupid-1][i], 'fff', dest_group_colors[groupid-1],
		  data, signal, mute);
      
    }
  }

  
  sep = document.createElement("div");
  sep.style.clear = 'both';
  channels.appendChild(sep);
  
  document.getElementById("routingtable").appendChild(table);
}






function display_changed(val) {
  clear_all_port_tables();
  clear_all_group_tables();
  display = val;
  init_display();
}


function type_changed(newtype) {
  //alert("type_changed("+newtype+")");
  type = newtype;
  display_changed(display);
  update_toolbox_info();
}


function filter_changed(newfilter) {
  var p, o;

  filter = newfilter;

  switch(display) {
  case 1:
  case 2:
    for (p=1; p<=16; p++) {
      for (c=1; c<=64; c++) {
	o = document.getElementById("ch"+p+"_"+c);
	filter_channel(o, p, c);
      }
    }
    break;

  case 3: // group, port

    break;

  case 4: // group, group

    break;
  }
}


dialog_active = false;


function key_handler(e) {
  var o;

  if (!dialog_active) {
    switch (e.keyCode) {
    case 27:
      clear_channel_selection();
      break;
      
    case 82: // 'r'
      break;
      
    case 71: // 'g'
      break;
      
    case 87: // 'w'
      clear_routes();
      break;

    case 49: // '1'
      document.getElementById("show_t2").checked = true;
      type_changed(2);
      break;
      
    case 50: // '2'
      document.getElementById("show_t1").checked = true;
      type_changed(1);
      break;
      
    case 51: // '3'
      document.getElementById("show_d1").checked = true;
      display_changed(1);
      break;
      
    case 52:
      document.getElementById("show_d2").checked = true;
      display_changed(2);
      break;
      
    case 53:
      document.getElementById("show_d3").checked = true;
      display_changed(3);
      break;
      
    case 54: 
      document.getElementById("show_d4").checked = true;
      display_changed(4);
      break;
    }
  }
}


function channelview_addgroup(id, name, bgcolor) {
  var o, div = document.createElement("div");
  div.className = "channelview_group";
  div.id = "showgroup"+id;
  div.style.backgroundColor = '#'+bgcolor;

  o = document.createElement("input");
  o.type = 'checkbox';
  o.id = "show_g"+id;
  div.appendChild(o);

  o = document.createElement("span");
  o.innerHTML = name;
  div.appendChild(o);

  document.getElementById("filter_group_list").appendChild(div);
}


function init_display() {
  var cb, i;
  
  clear_selectionmask();
  clear_channel_selection();

  for (i=1; i<=2; i++) {
    if (document.getElementById("show_t"+i).checked) {
      type = i;
      i = 2;
    }
  }


  for (i=1; i<=4; i++) {
    if (document.getElementById("show_d"+i).checked) {
      display = i; 
      i=4;
    }
  }

  for (i=1; i<=6; i++) {
    if (document.getElementById("show_f"+i).checked) {
      filter = i; 
      i=6;
    }
  }

  switch (display) {
  case 1: // Port, Port ch.
  case 2: // Port, Group ch.
    hide_groups();

    for (var i=0; i<16; i++) {
      if ((type==1 && dest_ports[i]==1) || (type==2 && src_ports[i]==1)) {
	rebuild_port(i+1);
	if (type==1) {
	  cb = document.getElementById("show_dp"+(i+1));
	} else if (type==2) {
	  cb = document.getElementById("show_sp"+(i+1));
	}	  
	show_port(i+1, cb.checked);
      }
    }
    break;

  case 3: // Group, Port ch.
    hide_all_ports();

    if (type==1) {
      for (var i=0; i<dest_groups.length; i++) {
	cb = document.getElementById("show_g"+dest_groups[i]);
	add_group(dest_groups[i], type);
	show_group(dest_groups[i], cb.checked);
      }
    } else {
      for (var i=0; i<src_groups.length; i++) {
	cb = document.getElementById("show_g"+src_groups[i]);
	add_group(src_groups[i], type);
	show_group(src_groups[i], cb.checked);
      }
	
    }
    break;

  case 4: // Group, Group ch.
    hide_all_ports();

    if (type==1) {
      for (var i=0; i<channelgroup_names.length; i++) {
	cb = document.getElementById("show_g"+(i+1));
	rebuild_dest_group(i+1);
      }
    } else if (type==2) {
      for (var i=0; i<channelgroup_names.length; i++) {
	cb = document.getElementById("show_sg"+(i+1));
	rebuild_src_group(i+1);
      }
    }
    break;
  }

}


function init_routing() {
  channel_routing = channel_routing_online;

  for (i=0; i<channelgroup_names.length; i++) {
    channelview_addgroup(i+1, channelgroup_names[i], channelgroup_colors[i]);
  }

  init_display();

  document.addEventListener('keydown', key_handler, true);  
}
