/**
 * Network configuration
 * @copyright DOTEC
 * @author Florian Faber, florian.faber@directout.eu
 * @version 1 (05.08.2011)
 **/


function esc_msg_level(val) {
		set_selectactive(document.getElementById('sel_msg_level'), val);	
}

function esc_disable_ip_reset(val) {
		document.getElementById("note_ipreset_disabled").style.display = (val==1)?"block":"none";
}


function set_network(id) {
		document.getElementById('network_active').style.display = (id==parent.frames[0].settings_network)?"block":"none";
		document.getElementById('network_inactive').style.display = (id!=parent.frames[0].settings_network)?"block":"none";
		if (id>0) 
				document.getElementById('btn_save').innerHTML = (id==parent.frames[0].settings_network)?"Save and apply":"Save";
		else
				document.getElementById('btn_save').style.display = 'none';
		
		if (id==0) {
				document.getElementById('network_name').disabled = true;
				document.getElementById('network_hostname').disabled = true;
				document.getElementById('radio_dhcp').disabled = true;
				document.getElementById('radio_manual').disabled = true;
				document.getElementById('manual_ip').disabled = true;
				document.getElementById('manual_mask').disabled = true;
				document.getElementById('manual_gateway').disabled = true;
				document.getElementById('manual_dns1').disabled = true;
				document.getElementById('manual_dns2').disabled = true;
				document.getElementById('ntp_enable').disabled = true;
				document.getElementById('syslog_enable').disabled = true;
		}
}


var values_changed = false;

function value_changed() {
		document.getElementById("btn_save").disabled = false;
		values_changed = true;
}


function page_unload() {
		if (values_changed) {
				confirm("unload");
		}
}

function check_tf(tf, p) {
		if (p.test(tf.value)) {
				tf.style.background = 'white';
				return true;
		} 
		tf.style.background = '#f66';
		tf.focus();
		return false;
}


function check_hostname(tf) {
		return check_tf(tf, /^[a-zA-Z0-9_]+$/);
}

function check_servername(tf) {
		return check_tf(tf, /^[a-zA-Z0-9-_\.]+[a-zA-Z0-9_-]+$/);
}

function check_ip(tf) {
		//  return check_tf(tf, /^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$/);
		return check_tf(tf, /((^|\.)((25[0-5])|(2[0-4]\d)|(1\d\d)|([1-9]?\d))){4}$/)
}

function check_gw(tf) {
		if (check_ip(tf)) {
				var ipStr = document.getElementById("manual_ip").value;
				var subnetStr = document.getElementById("manual_mask").value;
				var gwStr = tf.value;
				if (checkGateway(ipStr, subnetStr, gwStr)) {
						return true;
				} else {
						alert("The gateway has to be in the same network as the device!");
						tf.style.background = '#f66';
						tf.focus();
				}
		}
		return false;
}

function check_port(tf) {
		if (check_tf(tf, /^[0-9]+$/)) {
				p = parseInt(tf.value, 10);
				if (p<65536) {
						tf.style.background = 'white';
						return true;
				} else {
						tf.style.background = '#f66';
						tf.focus();
				}
		}
		return false;
}


function update_adr_method(m) {
		if (network_id==0)
				return;
		
		switch(m) {
		case 0: // dhcp
				document.getElementById('radio_dhcp').checked = true;
				document.getElementById('manual_ip').disabled = true;
				document.getElementById('manual_mask').disabled = true;
				document.getElementById('manual_gateway').disabled = true;
				document.getElementById('manual_dns1').disabled = true;
				document.getElementById('manual_dns2').disabled = true;
				break;
		case 1: // manual
				document.getElementById('radio_manual').checked = true;
				document.getElementById('manual_ip').disabled = false;
				document.getElementById('manual_mask').disabled = false;
				document.getElementById('manual_gateway').disabled = false;
				document.getElementById('manual_dns1').disabled = false;
				document.getElementById('manual_dns2').disabled = false;
		}
}

function adr_method_changed() {
		if (document.getElementById('radio_dhcp').checked) {
				update_adr_method(0);
		} else if (document.getElementById('radio_manual').checked){
				update_adr_method(1);
		}
		value_changed();
}

function change_ntp(checked) {
		if (typeof(checked)=='boolean') {
				value_changed();
		} else {
				checked = (checked==1);
				document.getElementById('ntp_enable').checked = checked;
		}
		document.getElementById('ntp_tz').disabled = !checked;
		document.getElementById('ntp1').disabled = !checked;
		document.getElementById('ntp2').disabled = !checked;
}

function change_syslog(checked) {
		if (typeof(checked)=='boolean') {
				value_changed();
		} else {
				checked = (checked==1);
				document.getElementById('syslog_enable').checked = checked;
		}
		document.getElementById('syslog_ip').disabled = !checked;
		document.getElementById('syslog_port').disabled = !checked;
}

function change_smtp(checked) {
		if (typeof(checked)=='boolean') {
				value_changed();
		} else {
				checked = (checked==1);
				document.getElementById('smtp_enable').checked = checked;
		}
		document.getElementById('smtp_server').disabled = !checked;
		document.getElementById('smtp_port').disabled = !checked;
		document.getElementById('smtp_username').disabled = !checked;
		document.getElementById('smtp_password').disabled = !checked;
		document.getElementById('smtp_test_adr').disabled = !checked;
		document.getElementById('smtp_test_btn').disabled = !checked;
}


function save_response(res) {
		//document.getElementById("set_password").disabled = false;
		lines = res.split('\n');
		if (lines[1])
				document.getElementById(lines[1]).focus();
		if (lines[0]!='') {
				document.body.style.cursor = 'default';
				alert(lines[0]); 
		}
}


function save() {
		document.body.style.cursor = 'wait';
		values_changed = false;
		document.getElementById("btn_save").disabled = true;
		
		str = network_id+"\n";
		str += document.getElementById('network_name').value+"\n";
		str += document.getElementById('network_hostname').value+"\n";
		str += (document.getElementById('radio_dhcp').checked)?"0\n":"1\n";
		str += document.getElementById('manual_ip').value+"\n";
		str += document.getElementById('manual_mask').value+"\n";
		str += document.getElementById('manual_gateway').value+"\n";
		str += document.getElementById('manual_dns1').value+"\n";
		str += document.getElementById('manual_dns2').value+"\n";
		str += (document.getElementById('ntp_enable').checked)?"1\n":"0\n";
		str += document.getElementById('ntp1').value+"\n";
		str += document.getElementById('ntp2').value+"\n";
		str += get_selectactive(document.getElementById('ntp_tz'))+"\n";
		str += (document.getElementById('smtp_enable').checked)?"1\n":"0\n";
		str += document.getElementById('smtp_server').value+"\n";
		str += document.getElementById('smtp_port').value+"\n";
		str += document.getElementById('smtp_username').value+"\n";
		str += document.getElementById('smtp_password').value+"\n";
		str += (document.getElementById('syslog_enable').checked)?"1\n":"0\n";
		str += document.getElementById('syslog_ip').value+"\n";
		str += document.getElementById('syslog_port').value+"\n";
		str += (document.getElementById('snmp_enable').checked)?"1\n":"0\n";
		str += document.getElementById('snmp_rocommunity').value+"\n";
		str += document.getElementById('snmp_roip').value+"\n";
		str += document.getElementById('snmp_romask').value+"\n";
		str += document.getElementById('snmp_rwcommunity').value+"\n";
		str += document.getElementById('snmp_rwip').value+"\n";
		str += document.getElementById('snmp_rwmask').value+"\n";
		str += (document.getElementById('snmp_trapenable').checked)?"1\n":"0\n";
		str += document.getElementById('snmp_trapip').value+"\n";
		str += document.getElementById('snmp_trapport').value+"\n";
		str += document.getElementById('snmp_trapcommunity').value;
		
		post_call("/cmd/network_settings", str, save_response);
}


function update_default_ip(response) {
		var rows = response.split('\n');
		var link = document.getElementById('default_link');
		link.href = 'http://'+rows[4];
		link.innerHTML = rows[4];
}

function update_network(response) {
		var rows = response.split('\n');
		document.getElementById('network_name').value = rows[1];
		document.getElementById('network_hostname').value = rows[2];

		update_adr_method(parseInt(rows[3], 10));
		document.getElementById('manual_ip').value = rows[4];
		document.getElementById('manual_mask').value = rows[5];
		document.getElementById('manual_gateway').value = rows[6];
		document.getElementById('manual_dns1').value = rows[7];
		document.getElementById('manual_dns2').value = rows[8];

		change_ntp(rows[9]);
		document.getElementById('ntp1').value = rows[10];
		document.getElementById('ntp2').value = rows[11];
		set_selectactive(document.getElementById('ntp_tz'), rows[12]);
		
		change_smtp(rows[13]);
		document.getElementById('smtp_server').value = rows[14];
		document.getElementById('smtp_port').value = rows[15];
		document.getElementById('smtp_username').value = rows[16];
		document.getElementById('smtp_password').value = rows[17];

		change_syslog(rows[18]);
		document.getElementById('syslog_ip').value = rows[19];
		document.getElementById('syslog_port').value = rows[20];

		document.getElementById('snmp_enable').checked = (rows[21]==1);
		document.getElementById('snmp_rocommunity').value = rows[22];
		document.getElementById('snmp_roip').value = rows[23];
		document.getElementById('snmp_romask').value = rows[24];
		document.getElementById('snmp_rwcommunity').value = rows[25];
		document.getElementById('snmp_rwip').value = rows[26];
		document.getElementById('snmp_rwmask').value = rows[27];
		document.getElementById('snmp_trapenable').checked = (rows[28]==1);
		document.getElementById('snmp_trapip').value = rows[29];
		document.getElementById('snmp_trapport').value = rows[30];
		document.getElementById('snmp_trapcommunity').value = rows[31];

		if (parseInt(rows[3], 10)==1) { // manual address
				check_gw(document.getElementById("manual_gateway"));
		}
}


//

function config_network_init() {
    if (parent.frames[0].status_controller>1)
				document.getElementById("snmp_panel").style.display = 'block';
    
    ajax_call('/data/network?'+0, update_default_ip);
    ajax_call('/data/network?'+network_id, update_network);
    
    esc_msg_level(parent.frames[0].config_msg_level);
    
    set_network(network_id);
    
    document.getElementById("btn_save").disabled = true;

		esc_disable_ip_reset(parent.frames[0].config_ip_reset);
		
    //window.onbeforeunload = page_unload;
}





