var init_done = 0;


function update_user_list(response) {
	var t = document.getElementById('table_users');
	
	while (t.rows.length>1)
		t.deleteRow(1);

	var rows = response.split('\n');
	for (var i=0; i<rows.length; i++) {
		var line = rows[i].split(';');
		if (line[1]) {
			var row = t.insertRow(-1);
			if (i%2==1)
				row.className = "odd";

			var td = row.insertCell(0);
			td.innerHTML = line[2]+" ("+line[1]+")";
			
			td = row.insertCell(1);
			td.style.fontSize = "10px";
			td.style.textAlign = 'center';
			if (line[3]==0)
				td.innerHTML = 'X';
			else
				td.innerHTML = '';

			td = row.insertCell(2);
			td.style.fontSize = "10px";
			td.style.textAlign = 'center';
		  if (line[4]>0)
				td.innerHTML = line[4];
			else
				td.innerHTML = '-';

			td = row.insertCell(3);
			td.style.fontSize = "10px";
			if (line[4]>0)
				td.innerHTML = format_timestamp(line[5]);
			else
				td.innerHTML = '-';

			td = row.insertCell(4);
			td.style.fontSize = "10px";
			td.style.textAlign = 'center';
			if (line[6]==0)
				td.innerHTML = 'no';
			else
				td.innerHTML = 'yes';

			td = row.insertCell(5);
			if (line[0]>0) {
			  if (parent.frames[0].permissions.user_edit)
			    td.innerHTML += '<button onclick="user_edit('+line[0]+');">Edit..</button>';
			  if (parent.frames[0].permissions.user_add)
			    td.innerHTML += '<button onclick="user_edit(\'c'+line[0]+'\');"> Clone..</button>';
			  if (parent.frames[0].permissions.user_delete)
			    td.innerHTML += ' <img src="/img/del_project.png" width="18" height="18" style="vertical-align: middle;" onclick="user_delete('+line[0]+');" title="Delete user">';
			} else {
			  if (parent.frames[0].permissions.user_edit)
			    td.innerHTML += '<button onclick="user_edit('+line[0]+');">Edit..</button>';
			}
		}
	}
}


function system_userbase_changed() {
	ajax_call('/data/get_users', update_user_list);
	ajax_call('/data/permissions', update_permission_list);
}


function user_delete(id) {
	if (confirm("Really delete this user?"))
		ajax_call("/data/delete_user?"+id, system_userbase_changed);
}

function permission_delete(id) {
	if (confirm("Really delete this permission class?"))
		ajax_call('/cmd/permission_delete?'+id, cb_permission_deleted)
}


function cb_permission_deleted(res) {
	ajax_call('/data/permissions', update_permission_list);
}
	

var pp_ids = [2,3,5,6,9,14];


function create_col_2(data, td, i) {
	td.style.fontSize = "10px";
	td.style.textAlign = "center";
	td.innerHTML = data["perms"][i]["cnt_user"]+"/"+data["perms"][i]["cnt_optional"]+"/"+data["perms"][i]["cnt_plugin"];
}

function create_col_3(data, td, i) {
	var editable = (data["perms"][i]["id"]>3) && (data["perms"][i]["allowed"]==1);
	var cloneable = (data.perms.length<32) && (data["perms"][i]["allowed"]==1);
	td.innerHTML = '<button onclick="parent.frames[1].location=\'/en/config/permission.html?'+data["perms"][i]["id"]+'\';">'+(editable?"Edit..":"Show..")+'</button> <button onclick="parent.frames[1].location=\'/en/config/permission.html?c'+data["perms"][i]["id"]+'\';"'+(cloneable?"":" disabled")+'>Clone..</button>';	
	
	if (((parseInt(data["perms"][i]["cnt_user"], 10)+
				parseInt(data["perms"][i]["cnt_optional"], 10)+
				parseInt(data["perms"][i]["cnt_plugin"], 10))==0) && 
			(parseInt(data["perms"][i]["id"], 10)>3))
		td.innerHTML += ' <img src="/img/del_project.png" width="18" height="18" style="vertical-align: middle;" onclick="permission_delete('+data["perms"][i]["id"]+');" title="Delete permission class">';
}

function update_permission_list(response) {
	var t = document.getElementById('table_permissions');
	
	while (t.rows.length>1)
		t.deleteRow(1);

	while (t.rows[0].cells.length>2)
	  t.rows[0].removeChild(t.rows[0].cells[2]);

	for (var idx in pp_ids) {
	    var s = document.getElementById('pp_'+pp_ids[idx]);
	    s.options.length = 0;
	}

	var data = JSON.parse(response);

	for (var i=0; i<data.perms.length; i++) {
		var row = t.insertRow(-1);
		if (i%2==1)
			row.className = "odd";
		
		var td = row.insertCell(0);
		//td.innerHTML = data["perms"][i]["id"]+" "+data["perms"][i]["name"];
		td.innerHTML = data["perms"][i]["name"];
		
		td = row.insertCell(1);
		create_col_2(data, td, i);

		if (parent.frames[0].permissions.user_permissions) {
			if (i==0) 
				t.rows[0].appendChild(document.createElement('th'));
			
			td = row.insertCell(2);
			create_col_3(data, td, i);
		}

		for (var idx in pp_ids) {
			var o = document.createElement('option');
			o.value = data["perms"][i]["id"];
			o.text = data["perms"][i]["name"];
			document.getElementById('pp_'+pp_ids[idx]).add(o);
		}
	}

	var btn = document.getElementById("btn_permission_add");
	btn.disabled = (data["perms"].length>=32);

	for (var idx in pp_ids)
		esc_plugin_perms(pp_ids[idx], parent.frames[0].plugin_perms[pp_ids[idx]]);

	init_done = 1;
}


function update_usage_counts(response) {
	var data = JSON.parse(response);
	var t = document.getElementById('table_permissions');
	
	for (var i=0; i<data.perms.length; i++) {
		var row = t.rows[i+1];
		create_col_2(data, row.children[1], i);
		create_col_3(data, row.children[2], i);
	}
}


function pp_change(pluginid, permissionid) {
	ajax_call('/data/plugin_perm?'+pluginid+','+permissionid);
}

//


function permissions_updated() {
  document.getElementById("user_panel").className = ((parseInt(parent.frames[0].permissions.user_add,10)+parseInt(parent.frames[0].permissions.user_edit,10)+parseInt(parent.frames[0].permissions.user_delete,10))==0)?"config_panel disabled":"config_panel";
  document.getElementById("btn_user_add").disabled = (parent.frames[0].permissions.user_add==0);

  document.getElementById("permission_panel").className = (parent.frames[0].permissions.user_permissions==0)?"config_panel disabled":"config_panel";
  document.getElementById("btn_permission_add").disabled = (parent.frames[0].permissions.user_permissions==0);

  document.getElementById("plugin_panel").className = (parent.frames[0].permissions.user_permissions==0)?"config_panel disabled":"config_panel";

  ajax_call('/data/get_users', update_user_list);
  ajax_call('/data/permissions', update_permission_list);
}


//


function esc_plugin_perms(pluginid, permissionid) {
	var s = document.getElementById('pp_'+pluginid);
	if (s)
		set_selectactive(s, permissionid);
	if (init_done)
		ajax_call('/data/permissions', update_usage_counts);
}


//


function config_user_init() {
  expand_init('config_user');
  permissions_updated();

}


window.onload = config_user_init;
