/**
 * M1k2 matrix toolbox
 * (c) D.O.Tec, http://www.directout.eu
 * @version 1 (02.12.2010) Florian Faber, florian.faber@directout.eu
 *
 * Include it and provide the following JS callbacks:
 *   matrix_set_mode(int)
 *   matrix_set_tool(int)
 *   matrix_snapshot()
 *   matrix_recall()
 *   matrix_copy()
 *   matrix_clear()
 *   matrix_commit()
 *
 * toolbox accesses the following global variables:
 *   matrix_mode - 1=offline, 2=online
 **/

matrixtoolbox = null;
matrixtoolbox_marker = null;


function matrixtoolbox_setmode(newmode, init) {
		if (newmode=="") {
				newmode='a';
				init = true;
		}
		
	  switch(newmode) {
		case 'o':
				matrixtoolbox.style.backgroundImage = 'url("/img/matrix_toolbox_offline.png")';
				matrix_set_mode('o');
				break;
				
		case 'a':
				matrixtoolbox.style.backgroundImage = 'url("/img/matrix_toolbox_online.png")';
				matrix_set_mode('a');
				break;
		}
		
		if (!init)
				post_call('/wwwdata?matrix_mode', newmode, false);
}


function matrixtoolbox_settool(newtool) {
  if (newtool==matrix_tool) return;

  switch(newtool) {
  case 1:
    matrixtoolbox_marker.style.left = "6px";
    matrixtoolbox_marker.style.top = "54px";
    break;

  case 2:
    matrixtoolbox_marker.style.left = "35px";
    matrixtoolbox_marker.style.top = "54px";
    break;

  case 3:
    matrixtoolbox_marker.style.left = "64px";
    matrixtoolbox_marker.style.top = "54px";
    break;
  }

  matrix_set_tool(newtool);
}


function matrixtoolbox_mousedown(e) {
  var x = (e.offsetX)?e.offsetX:e.layerX;
  var y = (e.offsetY)?e.offsetY:e.layerY;
  
  if ((y>=30) && (y<=48)) {
    matrixtoolbox_setmode((matrix_mode=='a')?'o':'a', false);
  } else if ((y>=54) && (y<=82)) {
    if ((x>=6) && (x<=34)) {
      matrixtoolbox_settool(1);
    } else if ((x>=35) && (x<=63)) {
      matrixtoolbox_settool(2);
    } else if ((x>=64) && (x<=90)) {
      matrixtoolbox_settool(3);
    }
  } else if ((y>=94) && (y<=114) && (x>=11) && (x<=88)) {
    matrix_snapshot(e.shiftKey);
  } else if ((y>=118) && (y<=138) && (x>=11) && (x<=88)) {
    matrix_recall_trigger(e.shiftKey);
  } else if ((y>=144) && (y<=164) && (x>=11) && (x<=88)) {
    matrix_copy();
  } else if ((y>=169) && (y<=189) && (x>=11) && (x<=88)) {
		if (e.shiftKey) {
			matrix_clear();
		} else {
			alert("Please hold down the shift key while klicking on the CLEAR button to enable the function.");
		}
  } else if ((y>=200) && (y<=220) && (x>=11) && (x<=88)) {
    if (e.shiftKey || confirm("Are you sure to commit the offline matrix?")) {
      matrix_commit();
    } 
  }
}


function matrixtoolbox_init() {
  var i, o;

  matrixtoolbox = document.getElementById("matrixtoolbox");
  matrixtoolbox_marker = document.getElementById("matrixtoolbox_marker");

  matrixtoolbox.addEventListener("mousedown", matrixtoolbox_mousedown, true);

  ajax_call('/wwwdata?matrix_mode', matrixtoolbox_setmode);
  matrixtoolbox_settool(1);
}



matrixtoolbox_init();
