/**
 * @copyright Florian Faber, florian.faber@directout.eu
 * @version 2 (05.05.2013) 
 *          - added permissions
 **/

var mini_hb, mini_vb, last_x, last_y, mini_size;
var inp;


//
// internal functions
//

function mini_hilight(x, y) {
	var bg;

	bg = mini_cb_color(x, y-1);
	
	mini_hb.style.background = '#'+bg;
	mini_hb.style.top = (y*23+1)+'px';
	mini_hb.style.width = ((x+1)*23+120)+'px';
	mini_hb.style.display = 'block';
	
	mini_vb.style.height = ((mini_size-y)*23+120)+'px';

	mini_vb.style.background = '#'+bg;
	mini_vb.style.left = (121+x*23)+'px';
	mini_vb.style.display = 'block';

	document.getElementById('matrix_top').style.cursor = mini_cb_cursor(x, y-1);
}


function mini_mousedown(e) {
	if (e.which!=1)
		return;

	var o = document.getElementById("xp_"+(last_x));
	var cur_y = Math.floor(parseInt(o.style.top, 10)/23);

	if ((cur_y==last_y) && (o.style.display=='block'))
		mini_cb_click(last_x, -1, e);
	else
		mini_cb_click(last_x, last_y-1, e);
}


function mini_mousemove(e) {
  var x, y;

	if (typeof(e.offsetX)=='number') {
		x = e.offsetX;
		y = e.offsetY;
	} else {
		x = e.layerX;
		y = e.layerY;
	}

  x = Math.floor(x/23);
  if (x<0) x=0;
  if (x>mini_size) x=mini_size;
  
  y = Math.floor(y/23);
  if (y<0) y=0;
  if (y>mini_size+1) y=mini_size+1;

  if ((x!=last_x) || (y!=last_y)) {
		mini_hilight(x, y);
		last_x = x;
		last_y = y;
	}
}


function mini_mouseout(e) {
	mini_hb.style.display = 'none';
	mini_vb.style.display = 'none';
	last_x = -1;
	last_y = -1;
}


function cb_btndown(e) {
	if (inp) {
		var srcElement;
		
		if (e.srcElement) {
			srcElement = e.srcElement;
		} else if (e.originalTarget) {
			srcElement = e.originalTarget;
		}		
		
		var col = document.getElementById('labelbox_label');		
		var con = document.getElementById('srclabelbox');
		if (!con)
			con = document.getElementById('dstlabelbox');

		if (con) {
			var el = srcElement;
			while (el) {
				if (el==con)
					return;
				el = el.parentElement;
			}
			
			mini_cb_label_changed(inp.labeltype, inp.labelid, inp.value, inp.fg, inp.bg);
			document.getElementById('matrix_container').removeChild(con);

			inp = false;

			mini_cb_input(false);

			e.preventDefault();
		}
			
	}
}


function cb_cchoser(value) {
	var label_rbg = document.getElementById('labelbox_label');
	inp.style.color = '#'+value.substring(0, 6);
	inp.style.backgroundColor = '#'+value.substring(6, 12);
	inp.fg = value.substring(0, 6);
	inp.bg = value.substring(6, 12);
}


function mini_expert_update() {
	var tf = document.getElementById('hex_fg');
	inp.style.color = '#'+tf.value;
	inp.fg = tf.value;
	
	tf = document.getElementById('hex_bg');
	inp.style.backgroundColor = '#'+tf.value;
	inp.bg = tf.value;
}


function mini_expert_filter(e) {
	var srcElement;
	
	if (e.srcElement) {
		srcElement = e.srcElement;
	} else if (e.originalTarget) {
		srcElement = e.originalTarget;
	}		
	
	if (srcElement.value.match(/^[0-9A-Fa-f]{6}$/)) {
		srcElement.style.backgroundColor = '#ffffff';
		mini_expert_update();
	} else {
		srcElement.style.backgroundColor = '#ff0000';
	}
}


function mini_create_editbox(cssid, fg, bg, meta) {
	var editbox = document.createElement("div");
	editbox.id = cssid;

	inp = document.createElement("input");
	inp.type = 'text';
	inp.className = 'labelinput';
 	inp.fg = fg;
	inp.style.color = '#'+inp.fg;
		inp.bg = bg;
		inp.maxLength = 16;
	inp.style.backgroundColor = '#'+inp.bg;

	editbox.appendChild(inp);
	
	if (meta) {
		// expert mode
		var c = document.createElement("input");
		c.type = 'text';
		c.className = 'hexinput';
		c.value = fg;
		c.id = 'hex_fg';
		c.style.left = '120px';
		//c.onchange = mini_expert_update;
		c.onkeyup = mini_expert_filter;
		editbox.appendChild(c);

		c = document.createElement("input");
		c.type = 'text';
		c.className = 'hexinput';
		c.value = bg;
		c.id = 'hex_bg';
		c.style.left = '180px';
		//c.onchange = mini_expert_update;
		c.onkeyup = mini_expert_filter;
		editbox.appendChild(c);

		editbox.style.width = "242px";

	} else {
		// label choser
		var label_rbg = create_radiobuttongroup('labelbox_label', cb_cchoser);
		radiobuttongroup_add(label_rbg, '000000ffffff', '<img src="/img/label_rgb_nolabel.png" width="20" height="20">');
		radiobuttongroup_add(label_rbg, '000000ff0000', '<img src="/img/label_rgb_red.png" width="20" height="20">');
		radiobuttongroup_add(label_rbg, '000000ff6300', '<img src="/img/label_rgb_orange.png" width="20" height="20">');
		radiobuttongroup_add(label_rbg, '000000ffd200', '<img src="/img/label_rgb_yellow.png" width="20" height="20">');
		radiobuttongroup_add(label_rbg, '00000035a000', '<img src="/img/label_rgb_green.png" width="20" height="20">');
		radiobuttongroup_add(label_rbg, '0000000040ff', '<img src="/img/label_rgb_blue.png" width="20" height="20">');
		radiobuttongroup_add(label_rbg, '0000009a40ff', '<img src="/img/label_rgb_purple.png" width="20" height="20">');
		radiobuttongroup_add(label_rbg, '000000878787', '<img src="/img/label_rgb_grey.png" width="20" height="20">');
		label_rbg.input = inp;
		editbox.appendChild(label_rbg);
		
		radiobuttongroup_select(label_rbg, fg+bg);
	}


	document.getElementById('matrix_container').appendChild(editbox);
	
	mini_cb_input(true);

	return editbox;
}


function mini_srclabelclick(e) {
  var srcElement;

  if (e.srcElement) {
    srcElement = e.srcElement;
    if (e.srcElement.srcid===undefined)
      return;
  } else if (e.originalTarget) {
    srcElement = e.originalTarget;
  }

	if (this!=srcElement)
		return;

  if (mini_cb_label_editable('src', srcElement.srcid)) {
		var srclabelbox = mini_create_editbox('srclabelbox', mini_cb_fg('src', srcElement.srcid), mini_cb_bg('src', srcElement.srcid), e.ctrlKey || e.metaKey);

		srclabelbox.style.top = (document.getElementById('srclabel_'+srcElement.srcid).offsetTop-2)+"px";

		inp.value = mini_cb_label('src', srcElement.srcid);
		inp.labelid = srcElement.srcid;
    inp.labeltype = 'src';
		inp.id = 'srclabelinput_'+inp.labelid;

    inp.focus();
  }
}


function mini_dstlabelclick(e) {
  var srcElement;

  if (e.srcElement) {
    srcElement = e.srcElement;
    if (e.srcElement.dstid===undefined)
      return;
  } else if (e.originalTarget) {
    srcElement = e.originalTarget;
  }

  if (mini_cb_label_editable('dst', srcElement.dstid)) {
		var dstlabelbox = mini_create_editbox('dstlabelbox', mini_cb_fg('dst', srcElement.dstid), mini_cb_bg('dst', srcElement.dstid), e.ctrlKey || e.metaKey);

		dstlabelbox.style.left = (118+srcElement.dstid*23)+"px";

		inp.value = mini_cb_label('dst', srcElement.dstid);
		inp.labelid = srcElement.dstid;
		inp.id = 'dstlabelinput_'+inp.labelid;
    inp.labeltype = 'dst';

    inp.focus();
  }
}


function mini_enable_in(id) {
	var o = document.getElementById("in_"+id+"_disabled");
	if (o) {
		o.parentNode.removeChild(o);
	}
}

function mini_disable_in(id) {
	var o = document.getElementById("in_"+id+"_disabled");
	if (!o) {
		o = document.createElement("div");
		o.className = 'disabled';
		o.style.position = "absolute";
		o.style.left = "0px";
		o.style.right = "0px";
		o.style.top = ((id+1)*23)+"px";
		o.style.height = "23px";
		o.style.background = "#666";
		o.style.opacity = 0.5;
		o.style.zIndex = 3;
		o.id = "in_"+id+"_disabled";
		
		var c = document.getElementById("matrix_xps");
		c.appendChild(o);
	}
}

function mini_enable_out(id) {
	var o = document.getElementById("out_"+id+"_disabled");
	if (o) {
		o.parentNode.removeChild(o);
	}
}

function mini_disable_out(id) {
	var o = document.getElementById("out_"+id+"_disabled");
	if (!o) {
		o = document.createElement("div");
		o.className = 'disabled';
		o.style.position = "absolute";
		o.style.left = (id*23)+"px";
		o.style.width = "23px";
		o.style.top = "0px";
		o.style.bottom = "0px";
		o.style.background = "#666";
		o.style.opacity = 0.5;
		o.style.zIndex = 3;
		o.id = "out_"+id+"_disabled";
		
		var c = document.getElementById("matrix_xps");
		c.appendChild(o);
	}
}


//
// functions to be called from outside
//


function mini_update_in(id) {
	var o = document.getElementById('srclabel_'+id);
	if (!o)
		return;

	if (mini_cb_enabled('src', id)) {
	  o.className = 'srcheader';
		mini_enable_in(id);
	} else {
	  o.className = 'srcheader disabled';
		mini_disable_in(id);
	}

	o.innerHTML = mini_cb_label('src', id);
	var c = mini_cb_bg('src', id);
	if (c!='')
	  o.style.background = '#'+c;
	c = mini_cb_fg('src', id);
	if (c!='')
	  o.style.color = '#'+c;
}


function mini_update_out(id) {
	var o = document.getElementById('dstlabel_'+id);
	if (!o)
		return;

	if (mini_cb_enabled('dst', id)) {
	  o.className = 'dstheader';
		mini_enable_out(id);
	} else {
	  o.className = 'dstheader disabled';
		mini_disable_out(id);
	}

	o.innerHTML = mini_cb_label('dst', id);
	o.style.background = '#'+mini_cb_bg('dst', id);
	o.style.color = '#'+mini_cb_fg('dst', id);
}


function mini_update_all() {
  for (var i=0; i<mini_size; i++) {
    mini_update_in(i);
    mini_update_out(i);
  }
}


function mini_update_xp(id, bg) {
	var o = document.getElementById('xp_'+id);
	if (!o)
		return;
	
	var cur_y = Math.floor(parseInt(o.style.top, 10)/23)-1;

	if (cur_y>=0)
		o.style.background = '#'+bg;
}


function mini_xp(x, y) {
	var o = document.getElementById('xp_'+x);
	if (!o)
		return;

	if (y==-2) {
		o.style.display = 'none';

	} else {
		o.style.display = 'block';

		bg = mini_cb_color(x, y);

		o.style.top = ((y+1)*23+1)+'px';
		o.style.background = '#'+bg;
	}
}


function init_minimatrix(size) {
	mini_size = size;

	var c = document.getElementById('matrix_container');
	c.style.width = (120+size*23)+'px';
	c.style.height = (120+(size+1)*23)+'px';

	c = document.getElementById('matrix_top');
	c.style.width = (size*23)+'px';
	c.style.height = ((size+1)*23)+'px';
	c.onmousemove = mini_mousemove;
	c.onmouseout = mini_mouseout;
	c.onmousedown = mini_mousedown;

	c = document.getElementById('matrix_bg');
	c.style.width = (size*23)+'px';
	c.style.height = ((size+1)*23)+'px';

	c = document.getElementById('matrix_xps');
	c.style.width = (size*23)+'px';
	c.style.height = ((size+1)*23)+'px';

	for (var i=0; i<size; i++) {
		var o = document.createElement('div');
		o.id = 'xp_'+i;
		o.className = 'minixp';
		o.style.top = '1px';
		o.style.left = (i*23+1)+'px';
		c.appendChild(o);
	}

	c = document.getElementById('srclabels');
	var o = document.createElement('div');
	o.innerHTML = mini_cb_label('src', -1);
	o.id = 'srclabel_nc';
	o.className = 'srcheader';
	o.style.top = '0px';
	c.appendChild(o);

	for (i=0; i<size; i++) {
		var o = document.createElement('div');
		o.innerHTML = mini_cb_label('src', i);
		o.id = 'srclabel_'+i;
		o.className = 'srcheader';
		o.srcid = i;
		o.style.top = ((i+1)*23)+'px';
		o.ondblclick = mini_srclabelclick;

		if (i==size-1)
			o.style.borderBottom = '1px solid #666';

		c.appendChild(o);
	}

	c = document.getElementById('dstlabels');
	for (i=0; i<size; i++) {
		var o = document.createElement('div');
		o.innerHTML = mini_cb_label('dst', i);
		o.id = 'dstlabel_'+i;
		o.dstid = i;
		o.className = 'dstheader';
		o.style.left = (i*23+1)+'px';
		if (i==0) {
			o.style.borderTop = '1px solid #666';
			o.style.left = (i*23)+'px';
		}
		o.ondblclick = mini_dstlabelclick;
		c.appendChild(o);
	}

	mini_hb = document.getElementById('hbar');
	mini_vb = document.getElementById('vbar');

	window.addEventListener('mousedown', cb_btndown, true);
}
