/**
 * M1k2 status page
 * (c) D.O.Tec, http://www.directout.eu
 * @version 1 (18.08.2011) Florian Faber, florian.faber@directout.eu
 **/

function ess_key_valid(val) {
    document.getElementById('device_key').innerHTML = (val==1)?"Valid":"INVALID";
}

function ess_controller(id) {
    document.getElementById('controller').innerHTML = id;
}

function ess_board(id) {
    document.getElementById('board').innerHTML = id;
}

function ess_serial(serial) {
    document.getElementById('serial').innerHTML = serial;
}

function ess_firmware(major, minor, build) {
    document.getElementById('fw_version').innerHTML = major+"."+minor+", Build "+build;
}

var io_ports = ["N/C", "BNC", "SC Multimode", "SC Singlemode", "ST Multimode", "ST Singlemode", "SFP", "SFP (smart)"];

function ess_io(id, serial, p1, p2, p3, p4, p5, p6, p7, p8, firmware) {
    if (firmware>0) {
	document.getElementById("iob"+(id+1)+"_serial").innerHTML = serial+", v"+firmware;
    } else {
	document.getElementById("iob"+(id+1)+"_serial").innerHTML = serial;
    }
    
    var t = document.getElementById("iob"+(id+1)+"_ports");
    t.rows[0].cells[1].innerHTML = io_ports[p1];
    t.rows[1].cells[1].innerHTML = io_ports[p2];
    t.rows[2].cells[1].innerHTML = io_ports[p3];
    t.rows[3].cells[1].innerHTML = io_ports[p4];
    t.rows[4].cells[1].innerHTML = io_ports[p5];
    t.rows[5].cells[1].innerHTML = io_ports[p6];
    t.rows[6].cells[1].innerHTML = io_ports[p7];
    t.rows[7].cells[1].innerHTML = io_ports[p8];    
}

function ess_io_present(id, p) {
    document.getElementById("iob"+(id+1)+"_present").innerHTML = (p==1)?"Yes":"No";
    document.getElementById("iob"+(id+1)+"_ports").style.display = (p==1)?"block":"none";
}

function ess_io_power(id, p) {
    document.getElementById("iob"+(id+1)+"_power").innerHTML = (p==1)?"Yes":"No";
}

//
//
//


function cb_version_website(str) {
    document.getElementById("version_website").innerHTML = str;
}
function cb_version_httpd(str) {
    document.getElementById("version_httpd").innerHTML = str;
}
function cb_version_controld(str) {
    document.getElementById("version_controld").innerHTML = str;
}
function cb_version_mdnsd(str) {
    document.getElementById("version_mdnsd").innerHTML = str;
}
function cb_version_syncd(str) {
    document.getElementById("version_syncd").innerHTML = str;
}
function cb_version_tempd(str) {
    document.getElementById("version_tempd").innerHTML = str;
}
function cb_version_fand(str) {
    document.getElementById("version_fand").innerHTML = str;
}
function cb_version_frontpaneld(str) {
    document.getElementById("version_frontpaneld").innerHTML = str;
}
function cb_version_telnetd(str) {
    document.getElementById("version_telnetd").innerHTML = str;
}
function cb_version_swp08d(str) {
    document.getElementById("version_swp08d").innerHTML = str;
}
function cb_version_midid(str) {
    document.getElementById("version_midid").innerHTML = str;
}
function cb_version_jsond(str) {
    document.getElementById("version_jsond").innerHTML = str;
}
function cb_version_jupiterd(str) {
    document.getElementById("version_jupiterd").innerHTML = str;
}
function cb_operating_hours(str) {
    document.getElementById("operating_hours").innerHTML = str+"h";
}
function cb_uptime(str) {
    var bla=str.split(" ");
    document.getElementById("uptime").innerHTML = format_duration(bla[0])+" ("+Math.round(100*bla[1]/bla[0])+"% idle)";
}
function cb_sdhc(str) {
		var o = document.getElementById("sdhc_update");
		o.innerHTML = (str.substring(0, 1)=="1")?"yes":"no";
}


//
//
//


function misc_status_init() {
    ajax_call("/website_version", cb_version_website);
    
    ajax_call("/data/version?httpd", cb_version_httpd);
    ajax_call("/data/version?controld", cb_version_controld);
    ajax_call("/data/version?tempd", cb_version_tempd);
    ajax_call("/data/version?mdnsd", cb_version_mdnsd);
    ajax_call("/data/version?syncd", cb_version_syncd);
    ajax_call("/data/version?fand", cb_version_fand);
    ajax_call("/data/version?frontpaneld", cb_version_frontpaneld);
    
    ajax_call("/data/version?telnetd", cb_version_telnetd);
    ajax_call("/data/version?swp08d", cb_version_swp08d);
    ajax_call("/data/version?midid", cb_version_midid);
    ajax_call("/data/version?httpd", cb_version_jsond);
    ajax_call("/data/version?jupiterd", cb_version_jupiterd);

		if (parent.frames[0].status_controller>1) {
				document.getElementById("sdhc_row").style.display = "none";
		} else {
				ajax_call("/sdhc.txt", cb_sdhc);
		}
		
    ajax_call("/data/operating_hours", cb_operating_hours);
    ajax_call("/data/uptime", cb_uptime);

    ess_key_valid(parent.frames[0].status_key);
    ess_controller(parent.frames[0].status_controller);
    ess_board(parent.frames[0].status_board);
    ess_serial(parent.frames[0].status_serial);
    ess_firmware(parent.frames[0].status_firmware[0], parent.frames[0].status_firmware[1], parent.frames[0].status_firmware[2]);
    
    ess_io(0, parent.frames[0].status_io_serial[0], parent.frames[0].status_io_ports[0][0], parent.frames[0].status_io_ports[0][1], parent.frames[0].status_io_ports[0][2], parent.frames[0].status_io_ports[0][3], parent.frames[0].status_io_ports[0][4], parent.frames[0].status_io_ports[0][5], parent.frames[0].status_io_ports[0][6], parent.frames[0].status_io_ports[0][7], parent.frames[0].status_io_firmware[0]);
    ess_io(1, parent.frames[0].status_io_serial[1], parent.frames[0].status_io_ports[1][0], parent.frames[0].status_io_ports[1][1], parent.frames[0].status_io_ports[1][2], parent.frames[0].status_io_ports[1][3], parent.frames[0].status_io_ports[1][4], parent.frames[0].status_io_ports[1][5], parent.frames[0].status_io_ports[1][6], parent.frames[0].status_io_ports[1][7], parent.frames[0].status_io_firmware[1]);

    ess_io_present(0, parent.frames[0].status_io_present[0]);
    ess_io_present(1, parent.frames[0].status_io_present[1]);
    ess_io_power(0, parent.frames[0].status_io_power[0]);
    ess_io_power(1, parent.frames[0].status_io_power[1]);	
}

window.onload = misc_status_init;
