

/**
 * Parse a string dotted decimal to an integer.
 * @returns -1 of string could not be parsed, ip otherwise.
 **/
function ipStrToInt(ipStr) {
		var decimals = ipStr.split(".");
		var ip = -1;
		if (decimals.length==4) {
				ip = (parseInt(decimals[0], 10)<<24) |
						(parseInt(decimals[1], 10)<<16) |
						(parseInt(decimals[2], 10)<<8) |
						parseInt(decimals[3], 10);
		}
		
		return ip;
}


/**
 * Checks if ipStr and gwStr are in the same net.
 * @returns true|false
 **/
function checkGateway(ipStr, subnetStr, gwStr) {
		var ip = ipStrToInt(ipStr);
		var subnet = ipStrToInt(subnetStr);
		var gw = ipStrToInt(gwStr);

		return ((ip & subnet) == (gw & subnet));
}
