/**
 * M1k2 notification toolkit
 * @copyright Florian Faber, florian.faber@directout.eu
 * @version 1 (26.01.2012) 
 **/

notifications_timeout = 5;
notifications_timer = false;
notifications_box = null;

function notifications_createbox() {
	if (notifications_box)
		return;

	notifications_box = document.createElement('div');
	notifications_box.id = "notifications_box";
	notifications_box.style.display = 'none';

	var con = document.createElement('div');
	con.id = "notifications_box_contents";
	notifications_box.appendChild(con);

	document.body.appendChild(notifications_box);
}


function notifications_fadein() {
	notifications_box.style.display = 'block';
}


function notifications_fadeout() {
	notifications_box.style.display = 'none';
	notifications_timer = false;
}


function notifications_countdown() {
	var found = false;
	for (var i=0; i<notifications_box.children[0].children.length; i++) {
		var msg = notifications_box.children[0].children[i];
		msg.timeout--;
		if (msg.timeout>0) {
			found = true;
		} else {
			notifications_box.children[0].removeChild(msg);
			i--;
		}
	}
	if (found)
		setTimeout("notifications_countdown()", 1000);
	else 
		notifications_fadeout();
		
}


function notifications_show(msg) {
	if (!notifications_box)
		notifications_createbox();

	if (notifications_box.style.display=='none')
		notifications_fadein();
	
	var n = document.createElement('div');
	n.className = "notifications_msg";
	n.innerHTML = msg;
	n.timeout = notifications_timeout;
	notifications_box.children[0].appendChild(n);
	if (!notifications_timer)
		notifications_timer = setTimeout("notifications_countdown()", 1000);
}


function notifications_init() {
	document.addEventListener("message", notifications_show);
}


