/**
 * M1k2 snapshot toolkit
 * @copyright Florian Faber, florian.faber@directout.eu
 * @version 1 (21.01.2012) 
 *
 **/


req = null;
sel_project = null;


function snapshot_close_store() {
	dialog_close('snapshot_store');
	req = null;
}


function cb_projects(res) {
  top.data_projects = res.split('\n');
}


function cb_snapshot_cancel() {
	snapshot_close_store();
}


function cb_store_response(res) {
	if (res=="OK") {
		parent.setTimeout("notifications_show('Snapshot stored'); ", 10);
		setTimeout("snapshot_close_store()", 10);
	} else {
		alert(res);
	}		
}


function cb_snapshot_ok() {
		var str = "";
		var pn = document.getElementById('snapshot_store_projectname');
		var pl = document.getElementById('snapshot_label');
		
		str += pn.value+"\n";
		str += pn.colval+"\n";
		str += pl.selvalue;
		post_call('/wwwdata?snapshot_last', str, false);

		str = "";
		str += pn.value+"\n";
		str += pn.colval.substr(0, 6)+"\n";
		str += pn.colval.substr(6, 12)+"\n";
		str += document.getElementById('snapshot_store_name').value+"\n";
		str += pl.selvalue.substr(0, 6)+"\n";
		str += pl.selvalue.substr(6, 12)+"\n";
		str += document.getElementById('snapshot_store_comment').value;
		post_call("/data/store_snapshot?"+((top.matrix_mode=='a')?"0":"1"), str, cb_store_response);
}


function snapshot_store_validate(e) {
	var tf_project = document.getElementById('snapshot_store_projectname');
	var tf_name = document.getElementById('snapshot_store_name');
	if ((tf_name.value!="") && (tf_project.value!="")) {
		enable_button('snapshot_store_ok');
	} else {
		disable_button('snapshot_store_ok');
	}
	if (e && (e.keyCode==27))
		cb_snapshot_cancel();
}


function cb_snapshot_store_label(value) {
	var tf = document.getElementById('snapshot_store_name');
	tf.style.color = '#'+value.substring(0, 6);
	tf.style.backgroundColor = '#'+value.substring(6, 12);
}


function snapshot_store_keyup(e) {
	if (e.keyCode==27) {
		cb_snapshot_cancel();
	} else if (e.keyCode==13) {
		var srcElement;
		
		if (e.srcElement) {
			srcElement = e.srcElement;
		} else if (e.originalTarget) {
			srcElement = e.originalTarget;
		}		

		if (srcElement.nodeName=="TEXTAREA")
			return;

		if (is_enabled('snapshot_store_ok'))
			cb_snapshot_ok();
	}		
}


function snapshot_store_defaults(res) {
	var data = res.split("\n");
	if (data.length==3) {
		snapshot_set_project(data[0], data[1].substring(0, 6), data[1].substring(6, 12));
		cb_snapshot_store_label(data[1]);
		radiobuttongroup_select(document.getElementById("snapshot_label"), data[2]);
		cb_snapshot_store_label(data[2]);
	}
}


function snapshot_store_init() {
	var title = "Store snapshot";
	req = init_dialog(title, "snapshot_store", 400, 250, true);
	var grid = create_grid(2);
	grid_add(grid, "<span class='gui_label'>Project:</span>");
	grid_add(grid, "<input type='text' style='margin-left: 0;' id='snapshot_store_projectname' readonly><button onclick='create_dialog_frame(parent.document, \"/en/dialogs/snapshot_project_select.html\", \"snapshot_project_select\", 400, 370, 99, false);'>Select..</button>");
	grid_add(grid, "<span class='gui_label'>Name:</span>");
	grid_add(grid, "<input type='text' style='width: 100%;' id='snapshot_store_name' onkeyup='snapshot_store_validate(event)' maxlength='63'>");
	grid_add(grid, "<span class='gui_label'>Comment:</span>");
	grid_add(grid, "<textarea style='width: 100%; height: 40px;' id='snapshot_store_comment'></textarea>");
	grid_add(grid, "<span class='gui_label'>Label:</span>");
	var label_rbg = create_radiobuttongroup('snapshot_label', cb_snapshot_store_label);
	radiobuttongroup_add(label_rbg, '000000ffffff', '<img src="/img/label_rgb_nolabel.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '000000ff0000', '<img src="/img/label_rgb_red.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '000000ff6300', '<img src="/img/label_rgb_orange.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '000000ffd200', '<img src="/img/label_rgb_yellow.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '00000035a000', '<img src="/img/label_rgb_green.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '0000000040ff', '<img src="/img/label_rgb_blue.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '0000009a40ff', '<img src="/img/label_rgb_purple.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '000000878787', '<img src="/img/label_rgb_grey.png" width="20" height="20">');
	grid_add(grid, label_rbg);
	dialog_add(req, grid);
    
	con = create_container("horizontal", "right");
	btn = create_button("Cancel", false, "btn_text", "snapshot_store_cancel", cb_snapshot_cancel);
	container_add(con, btn);
	btn = create_button("OK", false, "btn_text", "snapshot_store_ok", cb_snapshot_ok);
	container_add(con, btn);
	dialog_add_dialogbuttons(req, con);

	document.body.appendChild(req);

	radiobuttongroup_select(label_rbg, '000000ffffff');

	this.addEventListener('keyup', snapshot_store_keyup, false);

	ajax_call("/wwwdata?snapshot_last", snapshot_store_defaults);
	ajax_call("/data/projects", cb_projects);
		
	disable_button('snapshot_store_ok');
	document.getElementById('snapshot_store_name').focus();
}


function snapshot_set_project(name, fg, bg) {
	var tf = document.getElementById('snapshot_store_projectname');
	tf.value = name;
	tf.style.color = '#'+fg;
	tf.style.backgroundColor = '#'+bg;
	tf.colval = fg+""+bg;
}


function snapshot_close_project() {
	dialog_close("snapshot_project_select");
}


function cb_project_select_dblclick(elem) {
	// double click on list item
	var parent_dialog = parent.document.getElementById('snapshot_store');
	
	parent_dialog.contentWindow.snapshot_set_project(elem.data_str, elem.data_fg, elem.data_bg);
	parent_dialog.contentWindow.snapshot_store_validate();
	snapshot_close_project();
}


function cb_project_select_btn() {
	// "select" button
	cb_project_select_dblclick(list_get_selected(document.getElementById("list_project")));
}


function cb_project_selected(elem) {
	// invoked if the user selected an item from the list of projects
	enable_button('project_select');
}


function cb_project_create() {
	var parent_dialog = parent.document.getElementById('snapshot_store');
	
	parent_dialog.contentWindow.snapshot_set_project(document.getElementById('project_name').value, document.getElementById('project_label').selvalue.substring(0, 6), document.getElementById('project_label').selvalue.substring(6, 12));
	parent_dialog.contentWindow.snapshot_store_validate();
	snapshot_close_project();
}


function cb_project_cancel() {
	snapshot_close_project();
}
   

function cb_project_label(value) {
	var tf = document.getElementById('project_name');
	tf.style.color = '#'+value.substring(0, 6);
	tf.style.backgroundColor = '#'+value.substring(6, 12);
}


function project_create_validate() {
	var tf_name = document.getElementById('project_name');
	if (tf_name.value!="") {
		enable_button('project_create');
	} else {
		disable_button('project_create');
	}
}


function snapshot_project_init() {
	var dia_div = init_dialog("Select project", "snapshot_project", 400, 370, true);
	var sep = create_separator("Select existing project");
	dialog_add(dia_div, sep);
	var list = create_list("list_project", 360, 100, cb_project_selected, cb_project_select_dblclick);
	dialog_add(dia_div, list);
	var con = create_container("horizontal", "right");
	btn = create_button("Select", false, "btn_text", "project_select", cb_project_select_btn);
	container_add(con, btn);
	dialog_add(dia_div, con);

	sep = create_separator("Create a new project");
	dialog_add(dia_div, sep);
	var grid = create_grid(2);
	grid_add(grid, "<span class='gui_label'>Name:</span>");
	grid_add(grid, "<input type='text' style='width: 100%; margin-left: 0;' id='project_name' onkeyup='project_create_validate();'>");
	grid_add(grid, "<span class='gui_label'>Label:</span>");
	var label_rbg = create_radiobuttongroup('project_label', cb_project_label);
	radiobuttongroup_add(label_rbg, '000000ffffff', '<img src="/img/label_rgb_nolabel.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '000000ff0000', '<img src="/img/label_rgb_red.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '000000ff6300', '<img src="/img/label_rgb_orange.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '000000ffd200', '<img src="/img/label_rgb_yellow.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '00000035a000', '<img src="/img/label_rgb_green.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '0000000040ff', '<img src="/img/label_rgb_blue.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '0000009a40ff', '<img src="/img/label_rgb_purple.png" width="20" height="20">');
	radiobuttongroup_add(label_rbg, '000000878787', '<img src="/img/label_rgb_grey.png" width="20" height="20">');
	radiobuttongroup_select(label_rbg, '000000ffffff');
	grid_add(grid, label_rbg);
	dialog_add(dia_div, grid);
    
	con = create_container("horizontal", "right");
	btn = create_button("Create project", false, "btn_text", "project_create", cb_project_create);
	container_add(con, btn);
	dialog_add(dia_div, con);

	con = create_container("horizontal", "right");
	btn = create_button("Cancel", false, "btn_text", "project_cancel", cb_project_cancel);
	container_add(con, btn);
	dialog_add_dialogbuttons(dia_div, con);

	document.body.appendChild(dia_div);

	if (top.data_projects && (top.data_projects.length>0)) {
		for (var i=0; i<top.data_projects.length; i++) {
			var elem = document.createElement('div');
			var values = top.data_projects[i].split(';', 3);
			elem.className = 'gui_list_item';
			elem.style.color = '#'+values[0];
			elem.data_fg = values[0];
			elem.style.backgroundColor = '#'+values[1];
			elem.data_bg = values[1];
			elem.data_str = values[2];
			elem.innerHTML = values[2];

			list_add(list, elem, values[2]);
		}
	}
	
	disable_button('project_select');
	disable_button('project_create');
}


//
//
//



function snapshot_restore_fill_projects() {
	var list = document.getElementById('list_project');

	for (var i=0; i<top.data_projects.length; i++) {
		var elem = document.createElement('div');
		var values = top.data_projects[i].split(';', 3);
		elem.className = 'gui_list_item';
		elem.style.color = '#'+values[0];
		elem.data_fg = values[0];
		elem.style.backgroundColor = '#'+values[1];
		elem.data_bg = values[1];
		elem.data_str = values[2];
		elem.innerHTML = values[2];
		
		list_add(list, elem, values[2]);
	}
}


function snapshot_close_recall() {
	dialog_close('snapshot_recall');
}


function snapshot_recall_details_show(e) {
	var details = document.getElementById('snapshot_details');
	var details_comment = document.getElementById('snapshot_details_comment');
  var srcElement;

  if (e.srcElement) {
    srcElement = e.srcElement;
  } else if (e.originalTarget) {
    srcElement = e.originalTarget;
  }

		if (srcElement.comment) {
				details_comment.innerHTML = srcElement.comment.replace("\n", "<br>");
		}
		details.style.display = 'block';
}


function snapshot_recall_details_hide(e) {
	var details = document.getElementById('snapshot_details');
	details.style.display = 'none';

}


function cb_recall_project_selected(selected_project) {
	var list = document.getElementById('list_snapshot');
	list_clear(list);
	disable_button('snapshot_recall_load');
	for (i=0; i<top.data_snapshots.length; i++) {
		var snap = top.data_snapshots[i].split(';');
		if (snap[3]==selected_project.value) {
			var elem = document.createElement('div');
			elem.className = 'gui_list_item';
			elem.style.color = '#'+snap[4];
			elem.data_fg = snap[4];
			elem.style.backgroundColor = '#'+snap[5];
			elem.data_bg = snap[5];
			elem.data_id = snap[0];
			elem.data_timestamp = snap[1];
			elem.data_name = urldecode(snap[6]);
			var d = new Date(snap[1]*1000);
			elem.innerHTML = urldecode(snap[6])+"<div style='float: right; font-size: 0.8em;'>"+snap[2]+"</div>";
			snap[7] = urldecode(snap[7]).replace(/^\s+|\s+$/g,"");
			if (snap[7] && (snap[7].length>0)) {
				elem.comment = snap[7].replace("\n", "<br>");
				elem.onmouseover = snapshot_recall_details_show;
				elem.onmouseout = snapshot_recall_details_hide;
			} else {
				elem.comment = false;
			}

			list_add(list, elem, snap[0]);
		}
	}
}

function cb_recall_snapshot_selected() {
	enable_button('snapshot_recall_load');
}

function cb_recall_snapshot_dbclick() {
	cb_recall_snapshot_load();
}

function cb_recall_snapshot_cancel() {
	snapshot_close_recall();
}


function cb_recall_snapshot_loaded(res) {
	if (res=="OK") {
		setTimeout("snapshot_close_recall()", 10);
	} else {
		alert(res);
	}		
}


function cb_recall_snapshot_load() {
	var params = 0;

	parent.setTimeout("notifications_show('Loading snapshot..'); ", 10);

	store_snapshot_items();

	params = parseInt(get_selectactive(document.getElementById('load_audioxp')), 10);

	if (document.getElementById('load_portgains').checked)
		params += 16;
	if (document.getElementById('load_gains').checked)
		params += 32;
	if (document.getElementById('load_locks').checked)
		params += 64;
	if (document.getElementById('load_midi').checked)
		params += 128;
	if (document.getElementById('load_serial').checked)
		params += 256;
	if (document.getElementById('load_labels').checked)
		params += 512;
	if (document.getElementById('load_portconfig').checked)
		params += 1024;
	if (document.getElementById('load_clockconfig').checked)
		params += 2048;
	
	ajax_call("/cmd/snapshot_recall?"+document.getElementById('list_snapshot').selvalue+","+params, cb_recall_snapshot_loaded);
}


function cb_recall_projects(res) {
	top.data_projects = res.split('\n');
	snapshot_restore_fill_projects();	
	ajax_call("/wwwdata?snapshot_last", snapshot_recall_defaults);
}


function cb_recall_snapshots(res) {
	top.data_snapshots = res.split('\n');
}


function cb_recall_snapshot_items(res) {
	var vals = res.split('\n');
	if (vals.length!=9) {
		// default
		set_selectactive(document.getElementById('load_audioxp'), 4);
	} else {
		set_selectactive(document.getElementById('load_audioxp'), vals[0]);
		document.getElementById('load_portgains').checked = (vals[1]=='true');
		document.getElementById('load_serial').checked = (vals[2]=='true');
		document.getElementById('load_gains').checked = (vals[3]=='true');
		document.getElementById('load_midi').checked = (vals[4]=='true');
		document.getElementById('load_locks').checked = (vals[5]=='true');
		document.getElementById('load_labels').checked = (vals[6]=='true');
		document.getElementById('load_portconfig').checked = (vals[7]=='true');
		document.getElementById('load_clockconfig').checked = (vals[8]=='true');
	}
}


function store_snapshot_items() {
	var str = "";
	var le = list_get_selected(document.getElementById("list_project"));
	str += le.data_str+"\n";
	str += le.data_fg+le.data_bg+"\n";
	le = list_get_selected(document.getElementById("list_snapshot"));
	str += le.data_fg+le.data_bg;
	post_call('/wwwdata?snapshot_last', str, false);

	str = "";
	str += get_selectactive(document.getElementById('load_audioxp'))+"\n";
	str += document.getElementById('load_portgains').checked+"\n";
	str += document.getElementById('load_serial').checked+"\n";
	str += document.getElementById('load_gains').checked+"\n";
	str += document.getElementById('load_midi').checked+"\n";
	str += document.getElementById('load_locks').checked+"\n";
	str += document.getElementById('load_labels').checked+"\n";
	str += document.getElementById('load_portconfig').checked+"\n";
	str += document.getElementById('load_clockconfig').checked;

	post_call('/wwwdata?snapshot_recall_items', str, false);
}


function snapshot_recall_keyup(e) {
	if (e.keyCode==27) {
		cb_recall_snapshot_cancel();
	} else if (e.keyCode==13) {
		if (is_enabled('snapshot_recall_load'))
			cb_recall_snapshot_load();
	}		
}


function snapshot_recall_defaults(res) {
	var data = res.split("\n");
	if (data.length==3) {
		var list = document.getElementById("list_project");
		list_select(list, data[0]);
		var le = list_get_selected(list);
		cb_recall_project_selected(le);
	}
}


function snapshot_recall_init() {
	req = init_dialog("Recall snapshot", "snapshot_recall", 550, 450, true);
	var grid = create_grid(2);
	var con_left = create_container("vertical", "top");
	var sep = create_separator("Select a project, then ..");
	container_add(con_left, sep);
	var list_projects = create_list("list_project", 200, 130, cb_recall_project_selected, false);
	container_add(con_left, list_projects);
	grid_add(grid, con_left);
	var con_right = create_container("vertical", "top");
	sep = create_separator(".. select a snapshot");
	container_add(con_right, sep);
	var list_snapshots = create_list("list_snapshot", 300, 130, cb_recall_snapshot_selected, cb_recall_snapshot_dbclick);
	container_add(con_right, list_snapshots);
	grid_add(grid, con_right);
	dialog_add(req, grid);

	// options
	sep = create_separator("Select items to restore");
	dialog_add(req, sep);
	var con = create_container("vertical", "top");
	var ng = create_grid(4);
	ng.style.fontSize = "0.8em";
	ng.style.align = "center";
	ng.style.width = "80%";
	ng.style.marginLeft = "50px";
	grid_add(ng, "");
	grid_add(ng, "Audio XPs: <select style='position: relative; top: -4px;' id='load_audioxp'><option value='0'>Do nothing</option><option value='4'>On &rarr; On</option><option value='12'>On &rarr; Off</option><option value='1'>Off &rarr; On</option><option value='3'>Off &rarr; Off</option><option value='7'>On&rarr;On, Off&rarr;Off</option><option value='13'>On&rarr;Off, Off&rarr;On</option></select>");
	grid_add(ng, "");
	grid_add(ng, "");
	grid_add(ng, "<input type='checkbox' id='load_portgains'>");
	grid_add(ng, "Port gains");
	grid_add(ng, "<input type='checkbox' id='load_serial'>");
	grid_add(ng, "Serial matrix");
	grid_add(ng, "<input type='checkbox' id='load_gains'>");
	grid_add(ng, "Channel gains");
	grid_add(ng, "<input type='checkbox' id='load_midi'>");
	grid_add(ng, "MIDI matrix");
	grid_add(ng, "<input type='checkbox' id='load_locks'>");
	grid_add(ng, "Channel locks");
	grid_add(ng, "<input type='checkbox' id='load_labels'>");
	grid_add(ng, "Labels");
	grid_add(ng, "<input type='checkbox' id='load_portconfig'>");
	grid_add(ng, "<span style='color: red;'>Port configuration</span>");
	grid_add(ng, "");
	grid_add(ng, "");
	grid_add(ng, "<input type='checkbox' id='load_clockconfig'>");
	grid_add(ng, "<span style='color: red;'>Clock configuration</span>");

	container_add(con, ng);

	dialog_add(req, con);

	con = create_container("horizontal", "right");
	btn = create_button("Cancel", false, "btn_text", "snapshot_recall_cancel", cb_recall_snapshot_cancel);
	container_add(con, btn);
	btn = create_button("Load", false, "btn_text", "snapshot_recall_load", cb_recall_snapshot_load);
	container_add(con, btn);
	dialog_add_dialogbuttons(req, con);

	document.body.appendChild(req);

	this.addEventListener('keyup', snapshot_recall_keyup, false); 
	this.focus();

	ajax_call("/wwwdata?snapshot_recall_items", cb_recall_snapshot_items);
	ajax_call("/data/snapshots", cb_recall_snapshots);
	ajax_call("/data/projects", cb_recall_projects);
		
	disable_button('snapshot_recall_load');
}


//
//
//


function cb_import_snapshot_cancel() {
	dialog_close('snapshot_import');
}


function cb_import_snapshot_imported() {
	dialog_close('snapshot_import');
}


function cb_import_snapshot_ok() {
	var f = document.getElementById('file');
	if (f.value!="") {
		var form = document.getElementById('import_form');
		form.action = '/data/import_system_snapshot?'+top.customValue;
		form.submit();

	} else {
		ajax_call("/cmd/system_snapshot_import?"+document.getElementById('list_snapshot').selvalue+","+top.customValue, cb_import_snapshot_imported);
	}
}


function snapshot_import_init() {
	req = init_dialog("Import snapshot", "snapshot_import", 550, 350, true);
	var sep = create_separator("Either select a snapshot from your account, ..");
	dialog_add(req, sep);

	var grid = create_grid(2);
	var con_left = create_container("vertical", "top");
	var list_projects = create_list("list_project", 200, 130, cb_recall_project_selected, false);
	container_add(con_left, list_projects);
	grid_add(grid, con_left);
	var con_right = create_container("vertical", "top");
	var list_snapshots = create_list("list_snapshot", 300, 130, cb_recall_snapshot_selected, cb_import_snapshot_ok);
	container_add(con_right, list_snapshots);
	grid_add(grid, con_right);
	dialog_add(req, grid);

	// file dialog
	sep = create_separator(".. or import a snapshot from your computer.");
	dialog_add(req, sep);

	var con_file = create_container("vertical", "top");
	var p = document.createElement('div');
	p.style.position = 'relative';
	p.style.marginLeft = '15px';
	p.style.width = '100%';
	p.innerHTML = "<form action='foo' method='post' enctype='multipart/form-data' id='import_form'>Select file: <input type='file' name='snapshot' id='file' onchange='if (this.value!=\"\") enable_button(\"snapshot_recall_load\");'></form>";
	container_add(con_file, p);

	dialog_add(req, con_file);

	con = create_container("horizontal", "right");
	btn = create_button("Cancel", false, "btn_text", "snapshot_recall_cancel", cb_import_snapshot_cancel);
	container_add(con, btn);
	btn = create_button("Import", false, "btn_text", "snapshot_recall_load", cb_import_snapshot_ok);
	container_add(con, btn);
	dialog_add_dialogbuttons(req, con);

	document.body.appendChild(req);

	//this.addEventListener('keyup', snapshot_import_keyup, false); 
	this.focus();

	ajax_call("/data/snapshots", cb_recall_snapshots);
	ajax_call("/data/projects", cb_recall_projects);
		
	disable_button('snapshot_import_ok');
}

//
//
//


function snapshot() {
	create_dialog_frame(document, "/en/dialogs/snapshot_store.html", "snapshot_store", 400, 250, 98, true);
}


function restore() {
	create_dialog_frame(document, "/en/dialogs/snapshot_recall.html", "snapshot_recall", 550, 450, 98, true);
}


function snap_import(id) {
	create_dialog_frame(document, "/en/dialogs/snapshot_import.html?"+id, "snapshot_import", 550, 350, 98, true); 
}
