/**
 * Common utility functions.
 * @copyright D.O.TEC
 * @author Florian Faber, florian.faber@directout.eu
 * @version 1 (04.05.2011)
 **/

function hex2d(str, pos, l) {
	var res=0;
	for (var i=pos; i<pos+l; i++) {
		res *= 16;
		var c=str.charCodeAt(i);
		if ((c>=48) && (c<=57))
			res += c-48;
		else if ((c>=65) && (c<=70))
			res += c-65+10;
		else if ((c>=97) && (c<=102))
			res += c-97+10;
	}
	return res;
}

function utf8encode(str) {
	str = str.replace(/\r\n/g,"\n");
	var utftext = "";
	for (var n = 0; n < str.length; n++) {
		var c = str.charCodeAt(n);
		if (c < 128) {
			utftext += String.fromCharCode(c);
			}
		else if((c > 127) && (c < 2048)) {
			utftext += String.fromCharCode((c >> 6) | 192);
			utftext += String.fromCharCode((c & 63) | 128);
		}
		else {
			utftext += String.fromCharCode((c >> 12) | 224);
			utftext += String.fromCharCode(((c >> 6) & 63) | 128);
			utftext += String.fromCharCode((c & 63) | 128);
			}
	}
	return utftext;
}

function urldecode(str) {
	/*
	try {
		return decodeURI(str);
	} catch (e) {

	}
	*/
	//return (unescape(str));
	var res = "";
	var l=str.length;
	for (var i=0; i<l; i++) {
		if (str.charAt(i)=='%') {
			var c = hex2d(str, i+1, 2);
			//res += " ("+str.substr(i+1, 2)+"="+c+") "
				//if (c<128) {
			res += String.fromCharCode(c);
			/*} else if (c<2048) {
				res += String.fromCharCode((c>>6) | 192);
				res += String.fromCharCode((c&63) | 128);
				}*/
			i += 2;
		} else {
			res += str.charAt(i);
		}
	}

	return res;
}


function fade_set_opacity(obj, opacity) {
	if (!obj) 
		return;
	if (obj.filters&&obj.filters[0]){
		if (typeof obj.filters[0].opacity=="number") { //if IE6+
			obj.filters[0].opacity=opacity*100;
		} else { //else if IE5.5-
			obj.style.filter="alpha(opacity="+(opacity*100)+")";
		}        
	} else if (obj.style.MozOpacity) {
		obj.style.MozOpacity=opacity;
	} else if (obj.style.KhtmlOpacity) {
		obj.style.KhtmlOpacity=opacity;
	} else {
		obj.style.opacity=opacity;
	}
}


function format_timestamp(ts) {
  var d = new Date(ts*1000);
  return d.getFullYear()+"-"+((d.getMonth()<9)?'0':'')+(d.getMonth()+1)+"-"+((d.getDate()<10)?'0':'')+d.getDate()+" "+((d.getHours()<10)?'0':'')+d.getHours()+":"+((d.getMinutes()<10)?'0':'')+d.getMinutes()+":"+((d.getSeconds()<10)?'0':'')+d.getSeconds();
}


function format_duration(t) {
	var str="";

	if (t>86400) {
		str += (Math.floor(t/86400))+"d";
		t = t%86400;
	}
	if (t>3600) {
		str += (Math.floor(t/3600))+"h";
		t = t%3600;
	}
	if (t>60) {
		str += (Math.floor(t/60))+"m";
		t = t%60;
	}
	if (t>0) {
		str += Math.floor(t)+"s";
	}

	return str;
}


function post_call(cmd, val, callback) {
    var xhr; 
    try {  
	xhr = new ActiveXObject('Msxml2.XMLHTTP'); 
    } catch (e) {
	try {   
	    xhr = new ActiveXObject('Microsoft.XMLHTTP');   
	} catch (e2) {
	    try {  
		xhr = new XMLHttpRequest();     
	    } catch (e3) {  
		xhr = false;   
	    }
	}
    }
    
    if (callback) {
	xhr.onreadystatechange  = function() { 
	    if (4==xhr.readyState) {
		if (200==xhr.status) {
		    callback(xhr.responseText);
		}
	    }
	}
    };
    
    xhr.open("POST", cmd,  true); 
    xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xhr.send(val); 
}


function post_cmd(cmd, val) {
  var xhr; 
  try {  
    xhr = new ActiveXObject('Msxml2.XMLHTTP'); 
  } catch (e) {
    try {   
      xhr = new ActiveXObject('Microsoft.XMLHTTP');   
    } catch (e2) {
      try {  
        xhr = new XMLHttpRequest();     
      } catch (e3) {  
        xhr = false;   
      }
    }
  }
  xhr.open("POST", "/cmd/"+cmd,  true); 
	xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	//xhr.setRequestHeader("Content-length", val.length);
	//xhr.setRequestHeader("Connection", "close");
  xhr.send(val); 
}


function send_cmd(cmd) {
	//alert('send_cmd('+cmd+')');
  var xhr; 
  try {  
    xhr = new ActiveXObject('Msxml2.XMLHTTP'); 
  } catch (e) {
    try {   
      xhr = new ActiveXObject('Microsoft.XMLHTTP');   
    } catch (e2) {
      try {  
        xhr = new XMLHttpRequest();     
      } catch (e3) {  
        xhr = false;   
      }
    }
  }
  xhr.open("GET", "/cmd/"+cmd,  true); 
  xhr.send(null); 
}


function ajax_call(uri, callback) {
	var xhr; 
	try {  
		xhr = new ActiveXObject('Msxml2.XMLHTTP'); 
	} catch (e) {
		try {   
			xhr = new ActiveXObject('Microsoft.XMLHTTP');   
		} catch (e2) {
			try {  
				xhr = new XMLHttpRequest();     
			} catch (e3) {  
				xhr = false;   
			}
		}
	}
	
	if (callback) {
		xhr.onreadystatechange  = function() { 
			if (4==xhr.readyState) {
				if (200==xhr.status) {
				  callback(xhr.responseText);
				}
			}
		}
	};
	
	xhr.open("GET", uri,  true); 
	xhr.send(null); 
}

function get_selectactive(select) {
	var elem = select.children;
	for (var i=0; i<elem.length; i++) {
		if (elem[i].selected) {
			return elem[i].value;
		}
	}
	return 0;
}       

function set_selectactive(select, value) {
	var elem = select.children;
	for (var i=0; i<elem.length; i++) {
		if (elem[i].value==value) {
			elem[i].selected = true;
			return;
		}
	}
}


// section expand + collapse

var expand_pageid = false;

function expand_store() {
	if (!expand_pageid)
		return;

	var sections = document.getElementsByName("expandsection");
	var str = "";
	for (var i=0; i<sections.length; i++) 
		str += sections[i].id+'='+sections[i].style.display+'\n';
	post_call('/wwwdata?expand_'+expand_pageid, str, false);
}


function expand_set(id, open) {
	var button = document.getElementById(id+"_expander");
	var contents = document.getElementById(id);
	if (!(button && contents))
		return;

	if (open) {
		button.style.backgroundImage = 'url(/img/collapse.png)';
		button.expanded = true;
		contents.style.display = 'block';
	} else {
		button.style.backgroundImage = 'url(/img/expand.png)';
		button.expanded = false;
		contents.style.display = 'none';
	}
}

function expand(id) {
	expand_set(id, document.getElementById(id).style.display!='block');
	expand_store();
}

function expand_restore(res) {
	var lines = res.split('\n');
	for (var i=0; i<lines.length; i++) {
		var line = lines[i].split('=');
		if (line[0]!="")
			expand_set(line[0], line[1]=='block');
	}
}

function expand_init(pageid) {
	expand_pageid = pageid;
	ajax_call('/wwwdata?expand_'+expand_pageid, expand_restore);
}


function show_help(helpurl) {
  window.open('/help/'+helpurl, 'help', 'location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no,height=600,width=700');
}


function init_cycle_button(cb, choices, callback) {
  cb.choices = choices;
  cb.choice = 0;
  cb.callback = callback
  cb.children[0].innerHTML = choices[0];
  cb.onclick = function(){ push_cycle_button(cb); };
}


function push_cycle_button(cb) {
  cb.choice++; 
  if (cb.choice==cb.choices.length) 
    cb.choice = 0; 
  set_cycle_button(cb, cb.choice); 
  cb.callback(cb.choice);
}

function set_cycle_button(cb, value) {
  if (value>=cb.choices.length)
    value = cb.choices.length-1;
  else if (value<0)
    value = 0;

  cb.children[0].innerHTML = cb.choices[value];
  cb.choice = value;
}



function set_menu_fixed(fixed) {
  var cont = document.getElementById('menubox');

  if (fixed) {
    cont.style.position = "fixed";
  } else {
    cont.style.position = "absolute";
  }

	var img = document.getElementById('menu_fixed');
	if (!fixed) {
		img.src = '/img/menu_nonsticky.png';
		img.title = 'Make menu sticky';
		img.fixed = !fixed;
	} else {
		img.src = '/img/menu_sticky.png';
		img.title = 'Unstick menu';
		img.fixed = !fixed;
	}
}

function fix_menu(checked) {
  post_call('/wwwdata?menu_fixed', checked, false);

  set_menu_fixed(checked);
}

function menu_keyhandler(e) {
  if ((typeof input_active !== 'undefined') && input_active)
    return;

  if (e.srcElement && 
      ((e.srcElement.nodeName=="TEXTAREA") || 
       (e.srcElement.nodeName=="INPUT")))
    return;

  if (e.originalTarget &&
      ((e.originalTarget.type=="textarea") || 
       (e.originalTarget.type=="text")))
    return;

  if (e.which==109) { // 'm'
    toggle_menu_fixed();
    e.preventDefault();
  }
}

function init_menu(checked) {
  var cb = document.getElementById('menu_fixed');
  if (!cb)
    return;

  cb.checked = (checked=="true");
  set_menu_fixed(checked=="true");

  window.addEventListener('keypress', menu_keyhandler, false);
}

function toggle_menu_fixed() {
  var cb = document.getElementById('menu_fixed');
  cb.checked = !cb.checked;
  fix_menu(cb.checked);
}

